        program rf5new
!	Ver. 10/2015
!	Changes since last version: Minor corrections included.
!       MODIFIED by MJ&MJ,jr. marcel@cs.cas.cz in May, June 2010. 
!	Important changes when transfered into Fortran 90 
!       made inside can be found by searching for '2010'.
!       Suitable for numerical data and class labels as strings.
!       Classes need not be numbered 1,2,...nclass (=NoOfClasses). 
!       Representation of the class labels as strings, integers or reals
!       is admissible.
!       
!       [My file numbers are 33 for register.txt and 34 for reading train 
!       and test data files in the "main2".]
!
!       ORIGINAL
!       Copyright 2002-2003  Leo Breiman and Adele Cutler
!       This is free open source software but its use,in part or 
!       in whole,in any commercial product that is sold for profit 
!       is prohibited without the written consent of Leo Breiman 
!       and Adele Cutler.
!       We very much appreciate bug notices and suggested improvements.
!       leo@stat.berkeley.edu   adele@math.usu.edu
!       SET ALL PARAMETERS FIRST GROUP BELOW.  GENERALLY,
!       SETTING PARAMETERS TO ZERO TURNS THE CORRESPONDING
!       OPTION OFF. 
!       ALL RELEVANT OUTPUT FILES MUST BE GIVEN NAMES--SEE BELOW.
!
!       WORKING VARIABLES DECLARATIONS
        character msg1*39, msg2*39, txt*39,ParName*39,parstr*39,pb*39,chr
        character*25 stri(10000),stri1,stri2 !27.5.2010
        real xx
!       ATTRIBUTES DECLARATIONS
        character*255 datatrain, datatest
        integer mdim,ntrain,nclass,maxcat,ntest,&
        labelts,labeltr,mtry0,ndsize,jbt,look,lookcls,&
        jclasswt,mdim2nd,mselect,imp,interact,impn,&
        nprox,nrnn,noutlier,nscale,nprot,missfill,iviz,&
        isaverf,isavepar,isavefill,isaveprox,&
        irunrf,ireadpar,ireadfill,ireadprox,&
        isumout,idataout,impfastout,impout,impnout,interout,&
        iprotout,iproxout,iscaleout,ioutlierout
        integer nsample,nrnodes,mimp,near,&
        ifprot,ifscale,iftest,mdim0,ntest0,nprot0,nscale0,&
        ROC
!
        integer Sizereal, Sizeint, Sizedouble
        real, DIMENSION(:), ALLOCATABLE::aa !!! 11.6.2010
        integer, DIMENSION(:), ALLOCATABLE:: im 
        REAL(8), DIMENSION(:), ALLOCATABLE::dd 
!
!     ===================================================== 
!     print help:           <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< 
      if (iargc().LT.3) then
!       TEXTS
        write(*,*)
        write(*,*)'RandomForest modified by MJ&MJ,jr. during May and June 2010'  
        write(*,*)' Fortran 90 version with dynamic memory allocation. Last revision 22 Oct 2015.'  
        write(*,*)' Free under GNU General Public License.'
        write(*,*)' When published please cite as:'  
        write(*,*)' -Breiman,L.: Random Forests, Machine Learning Vol. 45, No. 1, pp. 5-32.(2001)'
        write(*,*)' -Jirina,M., Krayem,M.S., Jirina,M.,jr.: Adapting GNU Random Forest program' 
        write(*,*)'  for Unix and Windows. Proceedings of the 11th International Conference'
        write(*,*)'  of Numerical Analysis and Applied Mathematics 2013,'
        write(*,*)'  AIP Conf. Proc. 1558, pp. 337-340 (2013); doi: 10.1063/1.4825492,'
        write(*,*)'  AIP Publishing LLC 978-0-7354-1184-5 (2013).'
        write(*,*)' eventually:'
        write(*,*)' -Jirina,M., Jirina,M.,jr.: Testing Random Forest for Unix and Windows.'
        write(*,*)'  Technical Report No. V-1075, Institue of Computer Science AS CR, Prague,'
        write(*,*)'  Czech Republic (2010).'
        write(*,*)'       And also let us know (leo@stat.berkeley.edu, efficiency@post.cz)'
        msg1='Usage: prog.exe datatrain datatest mdim '
        msg2=' [named parameters]'
        write(*,*)msg1,msg2
        msg1='DESCRIBE DATA (with optional defaults)'
        write(*,*)msg1
        msg1='Data files: numeric with class labels a'
        msg2='s integers, reals, or strings.'
        write(*,*)msg1,msg2
        msg1='datatrain: training data file name'
        write(*,*)msg1
        msg1='datatest: testing data file name'
        write(*,*)msg1
        msg1='mdim: task dimensionality (number of va'
        msg2='riables)]'
        write(*,*)msg1,msg2
        msg1='Named parameters: Form: Parname=Parvalu'
        msg2='e.'
        write(*,*)msg1,msg2
        msg1='[ntrain: number of samples (cases) in t'
        msg2='he training data - NOT NECESSARY NOW!] '
        write(*,*)msg1,msg2
        msg1='[nclass: number of classes - NOT NECESS'
        msg2='ARY NOW!]'
        write(*,*)msg1,msg2
        msg1='[ntest: the number of samples (cases) i'
        msg2='n the test set. NOTE: Put ntest=1 if '
        write(*,*)msg1,msg2
        msg1='  there is no test set. Putting ntest=0'
        msg2=' may cause compiler complaints.'
        write(*,*)msg1,msg2
        msg1='  - NOT NECESSARY NOW if data test file'
        msg2=' exists!]'
        write(*,*)msg1,msg2
        msg1='maxcat: the largest number of values as'
        msg2='sumed by a categorical variable in data'
        write(*,*)msg1,msg2
        msg1='labeltr=1 if the data has class labels.'
        msg2=' If not, =1 or 2 adds a synthetic class'
        write(*,*)msg1,msg2
        msg1='labelts=0 if the test set has no class '
        msg2='labels, 1 if the test set has cl.labels'
        write(*,*)msg1,msg2     
        write(*,*)
!
        msg1='SET RUN PARAMETERS'
        write(*,*)msg1
!             123567801234567890123456789012345678901
        msg1='mtry0=number of variables randomly sele'
        msg2='cted at each node'
        write(*,*)msg1,msg2
        msg1=' Default=int(sqrt(float(mdim))+0.5), (o'
        msg2='riginally 2 later on 5). Needs tuning!'
        write(*,*)msg1,msg2
        msg1=' Begin with this value and try a value '
        msg2='twice as high and half as low. See manu'
        write(*,*)msg1,msg2
        msg1='ndsize=1=minimum node size'
        write(*,*)msg1
        msg1='jbt=500=number of trees to grow'
        write(*,*)msg1
        msg1='look=100=how often you want to check th'
        msg2='e prediction error'
        write(*,*)msg1,msg2
        msg1='lookcls=1=show on the screen or not'
        write(*,*)msg1
        msg1='jclasswt=0'
        write(*,*)msg1
        msg1='mdim2nd=0'
        write(*,*)msg1
        msg1='mselect=0'
        write(*,*)msg1
        write(*,*)
!
        msg1='OUTPUT CONTROLS; all defaults zero:'      
        write(*,*)msg1
        msg1='ROC=1 to get data for ROC curve i.e. ou'
        msg2='tputs for each test sample else 0.'
        write(*,*)msg1,msg2
        write(*,*)' (file roc.txt; default ROC=0.)'
        msg1='isumout   = 0/1 1=summary to screen. In'
        msg2='cludes err rates & confusion matrix'
        write(*,*)msg1,msg2
        msg1='idataout = 0/1/2 1=train,2=adds test'
        msg2='(7)'
        write(*,*)msg1,msg2
        msg1='impfastout = 0/1 1=gini fastimp(8)'
        write(*,*)msg1
        msg1='impout = 0/1/2 1=imp,2=to screen(9)'
        write(*,*)msg1
        msg1='impnout = 0/1 1=impn (10)'
        write(*,*)msg1
        msg1='interout=0/1/2 1=interaction,2=screen'
        msg2='(11)'
        write(*,*)msg1,msg2
        msg1='iprotout=0/1/2 1=prototypes,2=screen'
        msg2='(12)'
        write(*,*)msg1,msg2
        msg1='iproxout=0/1/2 1=prox,2=adds test(13)'
        write(*,*)msg1
        msg1='iscaleout = 0/1 1=scaling coors(14)'
        write(*,*)msg1
        msg1='ioutlierout=0/1/2 1=train,2=adds test'
        msg2='(15)'
        write(*,*)msg1,msg2
        write(*,*)
!
        msg1='NAME OUTPUT FILES FOR SAVING THE FOREST'
        msg2=' STRUCTURE'
        write(*,*)msg1,msg2
        msg1='isaverf=1  savedforest'
        write(*,*)msg1
        msg1='isavepar=1 savedparams'
        write(*,*)msg1
        msg1='isavefill=1 savedmissfill'
        write(*,*)msg1
        msg1='isaveprox=1 savedprox'
        write(*,*)msg1
        write(*,*)
        msg1='NAME OUTPUT FILES TO SAVE DATA FROM CUR'
        msg2='RENT RUN'
        write(*,*)msg1,msg2
!
        msg1='idataout=1 save-data-from-run'
        write(*,*)msg1
        msg1='impfastout=1 save-impfast'
        write(*,*)msg1
        msg1='impout=1 save-importance-data'
        write(*,*)msg1
        msg1='impnout=1 save-caseimp-data'
        write(*,*)msg1
        msg1='interout=1 save-pairwise-effects'
        write(*,*)msg1
        msg1='iprotout=1 save-protos'
        write(*,*)msg1
        msg1='iproxout>=1 save-run-proximities'
        write(*,*)msg1
        msg1='iscaleout=1 save-scale'
        write(*,*)msg1
        msg1='ioutlierout>=1 save-outliers'
        write(*,*)msg1
        msg1='iviz=1 the graphics program is to be us'
        msg2='ed.'
        write(*,*)msg1,msg2
        write(*,*)
        write(*,*)'GLOBAL LIMITS:'
        write(*,*)'  No. of classes: 10 000'
        write(*,*)'  No. of lines:'
        write(*,*)'    training data:  100 000'
        write(*,*)'    testing data: 1 000 000'
        write(*,*)'  Max. dimension:    10 000'
        write(*,*)

        stop
      endif
!
!       DEFAULTS of fixed parameters:   <<<<<<<<<<<<<<<<<<<
!               datatrain='data.train'
!               datatest='data.test'
!               mdim=9
!
!     evaluate fixed parameters:
      call getarg(1, datatrain)
      call getarg(2, datatest)
      call getarg(3, txt)
      read(txt, '(I10)') mdim
!
!     ======================================================
!       DEFAULTS:            <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
!               ntrain=169
!               nclass=6
                maxcat=1
                ntest=-45
                labeltr=1
                labelts=1
!     ELIMINATE SOME OF "DEFAULTS"   28 May 2010
!      write(*,*)'task dimension is ',mdim
!     ntrain=169  testing end of file:  <<<<<<<<<<<<<<<<<<<<
!     nclass=6    and setting the number of classes
      open(34,file=datatrain,status='old')

        do n=1,100
            stri(n)=' '
        enddo
        stri2=' '
        nclass=0
        do n=1,100000
                read(34,*,END=11) (xx,m=1,mdim),stri1
!               write(*,*)'stri1=',stri1(1:1),'=xx'
                do j=1,25
                    chr=stri1(j:j)
!                   write(*,*)'chr=',chr,'=='
                    read(chr,'(I1)',ERR=6)i  !o to i tu vubec nejde, obvykle nula
                enddo
   6            if(j.EQ.1) then ! 9.6.2010 
                    j=2
                endif
                stri2=stri1(1:j-1)
!               write(*,*)'j=',j,'x',stri2,'y'
                do i=1,100
!                   write(*,*)'i=',i,'x',stri2,'y',stri(i),'z'
                    if(stri2.EQ.stri(i))then
!                       write(*,*)j,'then','y',i
                        goto 10
                    else
                        if(i.GT.nclass)then!new class is added
                            nclass=nclass+1
                            stri(nclass)=stri2
!                           write(*,*)j,'else','y',nclass
                            goto 10
                        endif
                    endif
                enddo
   10           continue
        enddo
        close(34)
   11 continue
      ntrain=n-1
      LLL=mylen(datatrain)
      KKK=mylen(datatest)
      write(*,*)'Learn:',datatrain(1:LLL),'  test:',datatest(1:KKK)
      msg1='No. of rows of the lrn file, no.of lab:'
      write(*,*)msg1, ntrain, nclass


!     ntest=45  testing end of file:  <<<<<<<<<<<<<<<<<<<<<<
      open(34,file=datatest,status='old')
      do i=1,1000000
        read(34,*,END=20) (stri(j),j=1,mdim)
      enddo
   20 close(34)
      ntest=i-1
      msg1='No. of rows of the tst file is:'
      write(*,*)msg1, ntest
!
!
!
!
!       -------------------------------------------------------
!       OUTPUT CONTROLS 
!cc     parameter(
                isumout =       1!0/1           1=summary to screen
                idataout=       0!0/1/2 1=train,2=adds test(7)
                impfastout=     0!0/1           1=gini fastimp  (8)
                impout=         0!0/1/2         1=imp,2=to screen(9)
                impnout=        0!0/1           1=impn          (10)
                interout=       0!0/1/2 1=interaction,2=screen(11)
                iprotout=       0!0/1/2 1=prototypes,2=screen(12)
                iproxout=       0!0/1/2 1=prox,2=adds test(13)
                iscaleout=      0!0/1           1=scaling coors (14)
                ioutlierout=    0!0/1/2 1=train,2=adds test (15)
!
!       -------------------------------------------------------
!       CONTROL PARAMETERS
!
!cc     parameter(
!               SET RUN PARAMETERS
                ROC=0 
                mtry0=int(sqrt(float(mdim))+0.5) !2 later on 5
!               write(*,*)'mtry0=',mtry0
                ndsize=1
                jbt=500
                look=100
                lookcls=0
                jclasswt=0
                mdim2nd=0
                mselect=0
!       jbt=number of trees to grow
!       mtry=number of variables randomly selected at each node
!       look=how often you want to check the prediction error
!       ndsize=minimum node sizec
!
!               SET IMPORTANCE OPTIONS  
                imp=1
                interact=0
                impn=1
!
!               SET PROXIMITY COMPUTATIONS
                nprox=1
                nrnn=ntrain
!
!               SET OPTIONS BASED ON PROXIMITIES
                noutlier=0
                nscale=0
                nprot=0
!
!               REPLACE MISSING VALUES  
                code=-999
                missfill=0
!
!               GRAPHICS
                iviz=0
!
!               SAVING A FOREST
                isaverf=0
                isavepar=0
                isavefill=0
                isaveprox=0
!
!               RUNNING A SAVED FOREST
                irunrf=0
                ireadpar=0 !to read parameters, see line 1463 (starts with '888')
                ireadfill=0
                ireadprox=0
!
!
!    ====================================================
!    evaluate named parameters <<<<<<<<<<<<<<<<<<<<<<<<<<
      do i=4,iargc()
        call getarg(i, txt)
        j=len(txt)-1
        do while (txt(j:j) .ne. '=')
          j = j - 1
        enddo
        if (j.GT.0) then
          ParName=txt(1:j-1)
          k=1
          do while (txt(k:k) .ne. ' ')
            k = k + 1
          enddo
          parstr=txt(j+1:k-1)
          pb='ntrain'
          if(ParName.eq.pb) read(parstr, '(I10)') ntrain
          pb='nclass'
          if(ParName.eq.pb) read(parstr, '(I10)') nclass
          pb='maxcat'
          if(ParName.eq.pb) read(parstr, '(I10)') maxcat
          pb='ntest'
          if(ParName.eq.pb) read(parstr, '(I10)') ntest
          pb='labeltr'
          if(ParName.eq.pb) read(parstr, '(I10)') labeltr
          pb='labelts'
          if(ParName.eq.pb) read(parstr, '(I10)') labelts
          pb='mtry0'
          if(ParName.eq.pb) read(parstr, '(I10)') mtry0
!         
          pb='lookcls'
          if(ParName.eq.pb) read(parstr, '(I10)') lookcls
          pb='isumout'
          if(ParName.eq.pb) read(parstr, '(I10)') isumout
          pb='idataout'
          if(ParName.eq.pb) read(parstr, '(I10)') idataout
          pb='impfastout'
          if(ParName.eq.pb) read(parstr, '(I10)') impfastout
          pb='impout'
          if(ParName.eq.pb) read(parstr, '(I10)') impout
          pb='impnout'
          if(ParName.eq.pb) read(parstr, '(I10)') impnout
          pb='interout'
          if(ParName.eq.pb) read(parstr, '(I10)') interout
          pb='iprotout'
          if(ParName.eq.pb) read(parstr, '(I10)') iprotout
          pb='iproxout'
          if(ParName.eq.pb) read(parstr, '(I10)') iproxout
          pb='iscaleout'
          if(ParName.eq.pb) read(parstr, '(I10)') iscaleout
          pb='ioutlierout'
          if(ParName.eq.pb) read(parstr, '(I10)') ioutlierout
!         
          pb='isaverf'
          if(ParName.eq.pb) read(parstr, '(I10)') isaverf
          pb='isavepar'
          if(ParName.eq.pb) read(parstr, '(I10)') isavepar
          pb='isavefill'
          if(ParName.eq.pb) read(parstr, '(I10)') isavefill
          pb='isaveprox'
          if(ParName.eq.pb) read(parstr, '(I10)') isaveprox
!         
          pb='idataout'
          if(ParName.eq.pb) read(parstr, '(I10)') idataout
          pb='impfastout'
          if(ParName.eq.pb) read(parstr, '(I10)') impfastout
          pb='impout'
          if(ParName.eq.pb) read(parstr, '(I10)') impout
          pb='impnout'
          if(ParName.eq.pb) read(parstr, '(I10)') impnout
          pb='interout'
          if(ParName.eq.pb) read(parstr, '(I10)') interout
          pb='iprotout'
          if(ParName.eq.pb) read(parstr, '(I10)') iprotout
!
          pb='iproxout'
          if(ParName.eq.pb) read(parstr, '(I10)') iproxout
          pb='iscaleout'
          if(ParName.eq.pb) read(parstr, '(I10)') iscaleout
          pb='ioutlierout'
          if(ParName.eq.pb) read(parstr, '(I10)') ioutlierout
          pb='iviz'
          if(ParName.eq.pb) read(parstr, '(I10)') iviz
          pb='jbt'
          if(ParName.eq.pb) read(parstr, '(I10)') jbt
          pb='ROC'
          if(ParName.eq.pb) read(parstr, '(I10)') ROC
!
        endif
      enddo
!      msg1=datatrain
!      msg2=datatest
!      write(*,*)nclass
!      write(*,*)
!    ======================================================
!
!

!       -------------------------------------------------------
!       DERIVED PARAMETERS (DO NOT CHANGE)
!
!cc     parameter(
        nsample=(2-labeltr)*ntrain
        nrnodes=2*nsample+1
        mimp=imp*(mdim-1)+1
        ifprot=nprot/(nprot-.1)
        ifscale=nscale/(nscale-.1)
        iftest=ntest/(ntest-.1)
        nprot0=(1-ifprot)+nprot
        nscale0=(1-ifscale)+nscale
        ntest0=(1-iftest)+ntest
        mdim0=interact*(mdim-1)+1
        near=nprox*(nsample-1)+1
!
!       =======================================================
!       *********  ARRAYS FOR THE MAIN2 SUBROUTINE  ***********
!       =======================================================
!
!      compute beginnings of REAL arrays
        IIx=1
        IIxts=IIx+mdim*nsample
        IIv5=IIxts+mdim*ntest0
        IIv95=IIv5+mdim
        IItgini=IIv95+mdim
        IIzt=IItgini+mdim
        IIavgini=IIzt+mdim
        IIvotes=IIavgini+mdim
        IIeffect=IIvotes+mdim0*jbt
        IIteffect=IIeffect+mdim0*mdim0
        IIhist=IIteffect+mdim0*mdim0
        IIg=IIhist+(1+mdim0)*mdim0
        IIfill=IIg+mdim0
        IIrinpop=IIfill+mdim
        IIdgini=IIrinpop+near*jbt
        IIxbestsplit=IIdgini+nrnodes
        IItnodewt=IIxbestsplit+nrnodes
        IItw=IItnodewt+nrnodes
        IItn=IItw+nrnodes
        IIv=IItn+nrnodes
        IIwin=IIv+nsample
        IItemp=IIwin+nsample
        IIq=IItemp+nrnn
        IIdevout=IIq+nclass*nsample
        IIclasswt=IIdevout+nclass
        IIwr=IIclasswt+nclass
        IItmissts=IIwr+nclass
        IItmiss=IItmissts+nclass
        IItclasspop=IItmiss+nclass
        IIwl=IItclasspop+nclass
        IIrmedout=IIwl+nclass
        IItclasscat=IIrmedout+nclass
        IIqts=IItclasscat+nclass*maxcat
        IIclasspop=IIqts+nclass*ntest0
        IIsignif=IIclasspop+nclass*nrnodes
        IIzscore=IIsignif+mimp
        IIsqsd=IIzscore+mimp
        IIavimp=IIsqsd+mimp
        IIqimp=IIavimp+mimp
        IIqimpm=IIqimp+nsample
        IItout=IIqimpm+nsample*mimp
        IIouttr=IItout+near
        IIxc=IIouttr+near
        IIdn=IIxc+maxcat
        IIcp=IIdn+maxcat
        IIcm=IIcp+maxcat
        IIvotecat=IIcm+maxcat
        IIfreq=IIvotecat+maxcat
        IIwc=IIfreq+maxcat
        IIoutts=IIwc+nsample
        IIpopclass=IIoutts+ntest0
        IIprotlow=IIpopclass+nprot0*nclass
        IIprot=IIprotlow+mdim*nprot0*nclass
        IIprothigh=IIprot+mdim*nprot0*nclass
        IIprotfreq=IIprothigh+mdim*nprot0*nclass
        IIrpop=IIprotfreq+mdim*nprot0*nclass*maxcat
        IIprotv=IIrpop+nrnodes
        IIwtx=IIprotv+mdim*nprot0*nclass
        IIprotvlow=IIwtx+nsample
        IIprotvhigh=IIprotvlow+mdim*nprot0*nclass
        Sizereal=IIprotvhigh+mdim*nprot0*nclass
!
!      compute beginnings of INTEGER arrays
        IIcat=1
        IIiv=IIcat+mdim
        IImsm=IIiv+mdim
        IImuse=IImsm+mdim
        IIirnk=IImuse+mdim
        IImissing=IIirnk+mdim*jbt
        IIa=IImissing+mdim*near
        IIasave=IIa+mdim*nsample
        IIb=IIasave+mdim*nsample
        IIcl=IIb+mdim*nsample
        IIout=IIcl+nsample
        IInodextr=IIout+nsample
        IInodexvr=IInodextr+nsample
        IIjin=IInodexvr+nsample
        IIjoob=IIjin+nsample
        IIpjoob=IIjoob+nsample
        IIndbegin=IIpjoob+nsample
        IIjvr=IIndbegin+near*jbt
        IIjtr=IIjvr+nsample
        IIjest=IIjtr+nsample
        IIibest=IIjest+nsample
        IIisort=IIibest+nrnn
        IIloz=IIisort+nsample
        IIta=IIloz+near*nrnn
        IIncase=IIta+nsample
        IIidmove=IIncase+nsample
        IIkpop=IIidmove+nsample
        IIjests=IIkpop+nrnodes
        IIjts=IIjests+ntest0
        IIiwork=IIjts+ntest0
        IInodexts=IIiwork+near
        IIclts=IInodexts+ntest0
        IIimax=IIclts+ntest0
        IIjinb=IIimax+ntest0
        IIbestsplitnext=IIjinb+near*jbt
        IIbestvar=IIbestsplitnext+nrnodes
        IIbestsplit=IIbestvar+nrnodes
        IInodestatus=IIbestsplit+nrnodes
        IInodepop=IInodestatus+nrnodes
        IInodestart=IInodepop+nrnodes
        IInodeclass=IInodestart+nrnodes
        IIparent=IInodeclass+nrnodes
        IItreemap=IIparent+nrnodes
        IIncts=IItreemap+2*nrnodes
        IInc=IIncts+nclass
        IImtab=IInc+nclass
        IIncn=IImtab+nclass*nclass
        IIits=IIncn+near
        IIjpur=IIits+nsample
        IInpend=IIjpur+nrnn
        IIinear=IInpend+nclass
        IInrcat=IIinear+nrnn
        IIkcat=IInrcat+maxcat
        IIncatsplit=IIkcat+maxcat
        IInbestcat=IIncatsplit+maxcat
        IIncp=IInbestcat+maxcat*nrnodes
        IInodexb=IIncp+near
        IInpcase=IInodexb+near*jbt
        IIncount=IInpcase+near*jbt
        IInod=IIncount+near*jbt
        Sizeint=IInod+nrnodes
!
!      compute beginnings of double precision arrays
        KKprox=1
        KKy=KKprox+near*nrnn
        KKu=KKy+near
        KKdl=KKu+near
        KKxsc=KKdl+nscale0
        KKred=KKxsc+near*nscale0
        KKee=KKred+near
        KKev=KKee+near
        KKppr=KKev+near*nscale0
        Sizedouble=KKppr+near
!       test the total length
!
          write(*,*)'Sizereal=',Sizereal,'   Sizeint=',Sizeint,&
          '   Sizedouble=',Sizedouble
!!! 11.6.2010
ALLOCATE ( aa(Sizereal) )    ! Allocate heap space. 
ALLOCATE ( im(Sizeint) )     ! Allocate heap space. 
ALLOCATE ( dd(Sizedouble) )  ! Allocate heap space. 
!       -------------------------------------------------------
!
!       =======================================================
!       ***************  CALLING MAIN2 SUBROUTINE  ****************
!       =======================================================
!
        call main2(datatrain, datatest,&
        mdim,ntrain,nclass,maxcat,ntest,&
        labelts,labeltr,mtry0,ndsize,jbt,look,lookcls,&
        jclasswt,mdim2nd,mselect,imp,interact,impn,&
        nprox,nrnn,noutlier,nscale,nprot,missfill,iviz,&
        isaverf,isavepar,isavefill,isaveprox,&
        irunrf,ireadpar,ireadfill,ireadprox,&
        isumout,idataout,impfastout,impout,impnout,interout,&
        iprotout,iproxout,iscaleout,ioutlierout,&
        nsample,nrnodes,mimp,near,&
        ifprot,ifscale,iftest,mdim0,ntest0,nprot0,nscale0,&
! My control:
        ROC,&
!         REAL arrays
        aa(IIx),&
        aa(IIxts),&
        aa(IIv5),&
        aa(IIv95),&
        aa(IItgini),&
        aa(IIzt),&
        aa(IIavgini),&
        aa(IIvotes),&
        aa(IIeffect),&
        aa(IIteffect),&
        aa(IIhist),&
        aa(IIg),&
        aa(IIfill),&
        aa(IIrinpop),&
        aa(IIdgini),&
        aa(IIxbestsplit),&
        aa(IItnodewt),&
        aa(IItw),&
        aa(IItn),&
        aa(IIv),&
        aa(IIwin),&
        aa(IItemp),&
        aa(IIq),&
        aa(IIdevout),&
        aa(IIclasswt),&
        aa(IIwr),&
        aa(IItmissts),&
        aa(IItmiss),&
        aa(IItclasspop),&
        aa(IIwl),&
        aa(IIrmedout),&
        aa(IItclasscat),&
        aa(IIqts),&
        aa(IIclasspop),&
        aa(IIsignif),&
        aa(IIzscore),&
        aa(IIsqsd),&
        aa(IIavimp),&
        aa(IIqimp),&
        aa(IIqimpm),&
        aa(IItout),&
        aa(IIouttr),&
        aa(IIxc),&
        aa(IIdn),&
        aa(IIcp),&
        aa(IIcm),&
        aa(IIvotecat),&
        aa(IIfreq),&
        aa(IIwc),&
        aa(IIoutts),&
        aa(IIpopclass),&
        aa(IIprotlow),&
        aa(IIprot),&
        aa(IIprothigh),&
        aa(IIprotfreq),&
        aa(IIrpop),&
        aa(IIprotv),&
        aa(IIwtx),&
        aa(IIprotvlow),&
        aa(IIprotvhigh),&
!
!         INTEGER arrays
        im(IIcat),&
        im(IIiv),&
        im(IImsm),&
        im(IImuse),&
        im(IIirnk),&
        im(IImissing),&
        im(IIa),&
        im(IIasave),&
        im(IIb),&
        im(IIcl),&
        im(IIout),&
        im(IInodextr),&
        im(IInodexvr),&
        im(IIjin),&
        im(IIjoob),&
        im(IIpjoob),&
        im(IIndbegin),&
        im(IIjvr),&
        im(IIjtr),&
        im(IIjest),&
        im(IIibest),&
        im(IIisort),&
        im(IIloz),&
        im(IIta),&
        im(IIncase),&
        im(IIidmove),&
        im(IIkpop),&
        im(IIjests),&
        im(IIjts),&
        im(IIiwork),&
        im(IInodexts),&
        im(IIclts),&
        im(IIimax),&
        im(IIjinb),&
        im(IIbestsplitnext),&
        im(IIbestvar),&
        im(IIbestsplit),&
        im(IInodestatus),&
        im(IInodepop),&
        im(IInodestart),&
        im(IInodeclass),&
        im(IIparent),&
        im(IItreemap),&
        im(IIncts),&
        im(IInc),&
        im(IImtab),&
        im(IIncn),&
        im(IIits),&
        im(IIjpur),&
        im(IInpend),&
        im(IIinear),&
        im(IInrcat),&
        im(IIkcat),&
        im(IIncatsplit),&
        im(IInbestcat),&
        im(IIncp),&
        im(IInodexb),&
        im(IInpcase),&
        im(IIncount),&
        im(IInod),&
!
!!!             DOUBLE precision arrays
        dd(KKprox),&
        dd(KKy),&
        dd(KKu),&
        dd(KKdl),&
        dd(KKxsc),&
        dd(KKred),&
        dd(KKee),&
        dd(KKev),&
        dd(KKppr)&
        )
!
        return
        end ! OF THE MAIN
!
!
!
!
!
!
!       =======================================================
!       *******  MAIN REWRITTEN AS A SUBROUTINE MAIN2 *********
!       =======================================================
!
        subroutine main2(datatrain, datatest,&
        mdim,ntrain,nclass,maxcat,ntest,&
        labelts,labeltr,mtry0,ndsize,jbt,look,lookcls,&
        jclasswt,mdim2nd,mselect,imp,interact,impn,&
        nprox,nrnn,noutlier,nscale,nprot,missfill,iviz,&
        isaverf,isavepar,isavefill,isaveprox,&
        irunrf,ireadpar,ireadfill,ireadprox,&
        isumout,idataout,impfastout,impout,impnout,interout,&
        iprotout,iproxout,iscaleout,ioutlierout,&
        nsample,nrnodes,mimp,near,&
        ifprot,ifscale,iftest,mdim0,ntest0,nprot0,nscale0,&
! my control:
        ROC,&
! real arrays
        x,xts,v5,v95,tgini,zt,avgini,&
        votes,effect,teffect,hist,g,fill,rinpop,&
        dgini,xbestsplit,tnodewt,&
        tw,tn,v,win,temp,q,devout,classwt,wr,&
        tmissts,tmiss,tclasspop,wl,rmedout,tclasscat,qts,&
        classpop,signif,zscore,sqsd,avimp,qimp,qimpm,tout,&
        outtr,xc,dn,cp,cm,votecat,freq,wc,outts,&
        popclass,protlow,prot,prothigh,protfreq,rpop,&
        protv,wtx,protvlow,protvhigh,&
! integer arrays
        cat,iv,msm,&
        muse,irnk,missing,a,&
        asave,b,&
        cl,out,nodextr,nodexvr,&
        jin,joob,pjoob,ndbegin,&
        jvr,jtr,jest,ibest,&
        isort,loz,&
        ta,ncase,idmove,kpop,&
        jests,jts,iwork,&
        nodexts,clts,imax,jinb,&
        bestsplitnext,bestvar,bestsplit,&
        nodestatus,nodepop,nodestart,&
        nodeclass,parent,treemap,&
        ncts,nc,mtab,ncn,&
        its,jpur,npend,inear,&
        nrcat,kcat,ncatsplit,&
        nbestcat,ncp,nodexb,&
        npcase,ncount,nod,&
! DOUBLE precision arrays
        prox,&
        y,&
        u,&
        dl,&
        xsc,&
        red,&
        ee,&
        ev,&
        ppr&
        )
!
        character*255 datatrain, datatest
!
        integer mdim,ntrain,nclass,maxcat,ntest,&
        labelts,labeltr,mtry0,ndsize,jbt,look,lookcls,&
        jclasswt,mdim2nd,mselect,imp,interact,impn,&
        nprox,nrnn,noutlier,nscale,nprot,missfill,iviz,&
        isaverf,isavepar,isavefill,isaveprox,&
        irunrf,ireadpar,ireadfill,ireadprox,&
        isumout,idataout,impfastout,impout,impnout,interout,&
        iprotout,iproxout,iscaleout,ioutlierout,&
        nsample,nrnodes,mimp,near,&
        ifprot,ifscale,iftest,mdim0,ntest0,nprot0,nscale0,&
        ROC
!
        character*25 stri(100),stri1,stri2 !27.5.2010
        character chr
        real code,xx
        
!       -------------------------------------------------------
!       DIMENSIONING OF ARRAYS
!
        real x(mdim,nsample),xts(mdim,ntest0),v5(mdim),v95(mdim),&
        tgini(mdim),zt(mdim),avgini(mdim),&
        votes(mdim0,jbt),effect(mdim0,mdim0),teffect(mdim0,mdim0),&
        hist(0:mdim0,mdim0),g(mdim0),fill(mdim),rinpop(near,jbt),&
        dgini(nrnodes),xbestsplit(nrnodes),tnodewt(nrnodes),&
        tw(nrnodes),tn(nrnodes),v(nsample),win(nsample),temp(nrnn),&
        q(nclass,nsample),devout(nclass),classwt(nclass),wr(nclass),&
        tmissts(nclass),tmiss(nclass),tclasspop(nclass),wl(nclass),&
        rmedout(nclass),tclasscat(nclass,maxcat),qts(nclass,ntest0),&
        classpop(nclass,nrnodes),signif(mimp),zscore(mimp),sqsd(mimp),&
        avimp(mimp),qimp(nsample),qimpm(nsample,mimp),tout(near),&
        outtr(near),xc(maxcat),dn(maxcat),cp(maxcat),cm(maxcat),&
        votecat(maxcat),freq(maxcat),wc(nsample),outts(ntest0),&
        popclass(nprot0,nclass),protlow(mdim,nprot0,nclass),&
        prot(mdim,nprot0,nclass),prothigh(mdim,nprot0,nclass),&
        protfreq(mdim,nprot0,nclass,maxcat),rpop(nrnodes),&
        protv(mdim,nprot0,nclass),wtx(nsample),&
        protvlow(mdim,nprot0,nclass),protvhigh(mdim,nprot0,nclass)

        integer cat(mdim),iv(mdim),msm(mdim),&
        muse(mdim),irnk(mdim,jbt),missing(mdim,near),a(mdim,nsample),&
        asave(mdim,nsample),b(mdim,nsample),&
        cl(nsample),out(nsample),nodextr(nsample),nodexvr(nsample),&
        jin(nsample),joob(nsample),pjoob(nsample),ndbegin(near,jbt),&
        jvr(nsample),jtr(nsample),jest(nsample),ibest(nrnn),&
        isort(nsample),loz(near,nrnn),&
        ta(nsample),ncase(nsample),idmove(nsample),kpop(nrnodes),&
        jests(ntest0),jts(ntest0),iwork(near),&
        nodexts(ntest0),clts(ntest0),imax(ntest0),jinb(near,jbt),&
        bestsplitnext(nrnodes),bestvar(nrnodes),bestsplit(nrnodes),&
        nodestatus(nrnodes),nodepop(nrnodes),nodestart(nrnodes),&
        nodeclass(nrnodes),parent(nrnodes),treemap(2,nrnodes),&
        ncts(nclass),nc(nclass),mtab(nclass,nclass),ncn(near),&
        its(nsample),jpur(nrnn),npend(nclass),inear(nrnn),&
        nrcat(maxcat),kcat(maxcat),ncatsplit(maxcat),&
        nbestcat(maxcat,nrnodes),ncp(near),nodexb(near,jbt),&
        npcase(near,jbt),ncount(near,jbt),nod(nrnodes),nmfmax,&
        ncsplit,ncmax,nmissfill,ndimreps,nmf,nmd,iseed
!
!       -------------------------------------------------------
!       USED IN PROXIMITY AND SCALING
!
        double precision prox(near,nrnn),y(near),u(near),&
        dl(nscale0),xsc(near,nscale0),red(near),ee(near),&
        ev(near,nscale0),ppr(near)
!
        character*500 text
!
!       -------------------------------------------------------
!       SCALAR DECLARATIONS
!
        real errtr,errts,tavg,er,randomu
!
        integer mtry,n,m,mdimt,k,j,i,m1,jb,nuse,ndbigtree,jj,mr,&
        n0,n1,n2,n3,n4,n5,n6,n7
!
!       write(*,*)'after arrays declaration'
!
!       -------------------------------------------------------
!       READ OLD TREE STRUCTURE AND/OR PARAMETERS
!
        if (irunrf.eq.1)&
                open(1,file='savedforest',status='old')
        if (ireadpar.eq.1)&
                open(2,file='savedparams',status='old')
        if (ireadfill.eq.1)&
                open(3,file='savedmissfill',status='old')
        if (ireadprox.eq.1)&
                open(4,file='savedprox',status='old')
!
!       -------------------------------------------------------
!       NAME OUTPUT FILES FOR SAVING THE FOREST STRUCTURE
!
        if (isaverf.eq.1)&
                open(1,file='savedforest',status='replace')
        if (isavepar.eq.1)&
                open(2,file='savedparams',status='replace')
        if (isavefill.eq.1)&
                open(3,file='savedmissfill',status='replace')
        if (isaveprox.eq.1)&
                open(4,file='savedprox',status='replace')
!
!       -------------------------------------------------------
!       NAME OUTPUT FILES TO SAVE DATA FROM CURRENT RUN
!
        if (idataout.ge.1)&
                open(7,file='save-data-from-run',status='replace')
        if (impfastout.eq.1)&
                open(8,file='save-impfast',status='replace')
        if (impout.eq.1)&
                open(9,file='save-importance-data',status='replace')
        if (impnout.eq.1)&
                open(10,file='save-caseimp-data',status='replace')
        if (interout.eq.1)&
                open(11,file='save-pairwise-effects',status='replace')
        if (iprotout.eq.1)&
                open(12,file='save-protos',status='replace')
        if (iproxout.ge.1)&
                open(13,file='save-run-proximities',status='replace')
        if (iscaleout.eq.1)&
                open(14,file='save-scale',status='replace')
        if (ioutlierout.ge.1)&
                open(15,file='save-outliers',status='replace')
        if(iviz.eq.1) then
!               the graphics program expects files to be named in the 
!               following way:  
                open(21,file='data.txt',status='new')
                open(22,file='imp.txt',status='new')
                open(23,file='info.txt',status='new')
                open(24,file='par.txt',status='new')
                open(25,file='scale.txt',status='new')
                if (iprotout.eq.1) then
                        open(26,file='proto.txt',status='new')
                        open(27,file='protinf.txt',status='new')
                endif
                if(interact.eq.1) open(28,file='inter.txt',status='new')
                if(iproxout.ge.1) open(29,file='prox.txt',status='new')
        endif
!
!       -------------------------------------------------------
!       write(*,*)'     READ IN DATA--SEE MANUAL FOR FORMAT   27 May 2010'
!
!       do n=1,100
!           stri(n)=' '!!! <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
!       enddo
        stri2=' '
        nclass=0
        
        open(16, file=datatrain, status='old')
        do n=1,ntrain
                read(16,*) (x(m,n),m=1,mdim),stri1
!               write(*,*)'stri1=',stri1(1:1),'=xx'
                do j=1,25
                    chr=stri1(j:j)
                    read(chr,'(I1)',ERR=56)i  !o to i tu vubec nejde, obvykle nula
                enddo
   56           if(j.EQ.1) then ! 9.6.2010 
                    j=2
                endif
                stri2=stri1(1:j-1)
!               write(*,*)j,'x',stri2,'y'
                do i=1,100
                    if(stri2.EQ.stri(i))then
                        cl(n)=i
!                       write(*,*)j,'then',stri2,'y',cl(n)
                        goto 60
                    else
                        if(i.GT.nclass)then!new class is added
                            nclass=nclass+1
                            stri(nclass)=stri2
                            cl(n)=nclass
!                           write(*,*)j,'else',stri2,'y',cl(n)
                            goto 60
                        endif
                    endif
                enddo
!   60          write(*,*)cl(n)
   60           continue
        enddo
        close(16)
!        write(*,*)'final classes=',nclass
        if(ntest.gt.0) then
                open(17, file=datatest, status='old')
                if(labelts.ne.0) then
                        do n=1,ntest0
                                read(17,*) (xts(m,n),m=1,mdim),stri1 !xx !<<<<<<<<<<TADY
!                               write(*,*)'stri1=',stri1(1:1),'=xx'
                                do j=1,25
                                    chr=stri1(j:j)
                                    read(chr,'(I1)',ERR=66)i  !o to i tu vubec nejde, obvykle nula
                                enddo
   66                           if(j.EQ.1) then ! 9.6.2010 
                                    j=2
                                endif
                                stri2=stri1(1:j-1)
!                               write(*,*)j,'x',stri2,'y'
                                do i=1,100
                                    if(stri2.EQ.stri(i))then
                                        clts(n)=i
!                                       write(*,*)j,'then',stri2,'y',clts(n)
                                        goto 70
                                    else
                                        if(i.GT.nclass)then !assign to the last class
                                            clts(n)=nclass
!                                           write(*,*)j,'else',stri2,'y',clts(n)
                                            goto 70
                                        endif
                                    endif
                                enddo
   70                           continue
!                               write(*,*)'for tst sample',n,' desired class =',clts(n)
                        enddo
                else
                        do n=1,ntest0
                                read(17,*) (xts(m,n),m=1,mdim)
                        enddo
                endif
                close(17)
        endif
!
!       -------------------------------------------------------
!       SELECT SUBSET OF VARIABLES TO USE
!
        if(mselect.eq.0) then
                mdimt=mdim
                do k=1,mdim
                        msm(k)=k
                enddo
        endif
        if (mselect.eq.1) then
!               fill in which variables 
!               mdimt=
!               msm(1)=
!               ---
!               msm(mdimt)=
        endif
!
!       -------------------------------------------------------
!       SET CATEGORICAL VALUES
!
        do m=1,mdim
                cat(m)=1
        enddo
!       fill in cat(m) for all variables m for which cat(m)>1
!       do m=1,mdim
!               cat(m)=4
!       enddo
!
!       -------------------------------------------------------
!       SET CLASS WEIGHTS

        if(jclasswt.eq.0) then
                do j=1,nclass
                        classwt(j)=1
                enddo
        endif
        if(jclasswt.eq.1) then
!               fill in classwt(j) for each j:
!               classwt(1)=1.
!               classwt(2)=10.
        endif
!
!       =======================================================
!       **************  END OF USER INPUT  ********************
!       =======================================================
!
!       -------------------------------------------------------
!       MISC PARAMETERS (SHOULD NOT USUALLY NEED ADJUSTMENT)
        iseed=4351
        call sgrnd(iseed)
        nmfmax = 5      !number of iterations (iterative fillin)
        ncsplit = 25    !number of random splits (big categoricals)
        ncmax = 25      !big categorical has more than ncmax levels
!
!       -------------------------------------------------------
!       ERROR CHECKING
!
        call checkin(labelts,labeltr,nclass,lookcls,jclasswt,&
        mselect,mdim2nd,mdim,imp,impn,interact,nprox,nrnn,&
        nsample,noutlier,nscale,nprot,missfill,iviz,isaverf,&
        irunrf,isavepar,ireadpar,isavefill,ireadfill,isaveprox,&
        ireadprox,isumout,idataout,impfastout,impout,interout,&
        iprotout,iproxout,iscaleout,ioutlierout,cat,maxcat,cl)
!
!       -------------------------------------------------------
!       SPECIAL CASES - QUERY PARAMETERS OR USE SAVED TREE
!               
!       query parameters
        if(ireadpar.eq.1) goto 888
!               
!       use saved tree
        if(irunrf.eq.1) goto 999
!       
!       -------------------------------------------------------
!       INITIALIZATION
!
!       mtry will change if mdim2nd>0, so make it a variable
        mtry=mtry0
!
!       nmissfill is the number of missing-value-fillin loops
        nmissfill=1
        if(missfill.eq.2) nmissfill=nmfmax
!
!       ndimreps is 2 if we want to do variable selection,
!       otherwise it's 1
        ndimreps=1
        if(mdim2nd.gt.0) ndimreps=2
!
!       assign weights for equal weighting case 
!       (use getweights for unequal weighting case)
        if(jclasswt.eq.0) then
                do k=1,nrnodes
                        tnodewt(k)=1
                enddo
        endif
!
        if(labeltr.eq.1) then
                do n=1,nsample
                        wtx(n)=classwt(cl(n))
                enddo
        else
                do n=1,nsample
                        wtx(n)=1.0
                enddo
        endif
!
!       -------------------------------------------------------
!       IF DATA ARE UNLABELED, ADD A SYNTHETIC CLASS
!
        if(labeltr.eq.0) then
                call createclass(x,cl,ntrain,nsample,mdim)
        endif
!
!       -------------------------------------------------------
!       COUNT CLASS POPULATIONS
!
        call zerv(nc,nclass)
        do n=1,nsample
                nc(cl(n))=nc(cl(n))+1
        enddo
        if(ntest.gt.0.and.labelts.eq.1) then
                call zerv(ncts,nclass)
                do n=1,ntest0
                        ncts(clts(n))=ncts(clts(n))+1
                enddo
        endif
!
!       -------------------------------------------------------
!       DO PRELIMINARY MISSING DATA
!
        if(missfill.eq.1) then
                call roughfix(x,v,ncase,mdim,nsample,&
                cat,code,nrcat,maxcat,fill)
                if(ntest.gt.0) then
                        call xfill(xts,ntest,mdim,fill,code)
                endif
        endif
        if(missfill.eq.2) then
                do n=1,near
                        do m=1,mdim
                                if(abs(code-x(m,n)).lt.8.232D-11) then
                                        missing(m,n)=1
                                else 
                                        missing(m,n)=0
                                endif
                        enddo
                enddo
                call roughfix(x,v,ncase,mdim,nsample,&
                cat,code,nrcat,maxcat,fill)
        endif
!
!       -------------------------------------------------------
!       TOP OF LOOP FOR ITERATIVE MISSING VALUE FILL OR SUBSET SELECTION
!
        do nmd=1,ndimreps

        if(imp.gt.0) then
                call zervr(sqsd,mimp)
                call zervr(avimp,mimp)
        endif
        call zervr(avgini,mdim)
        if(impn.eq.1) then
                call zervr(qimp,nsample)
                call zermr(qimpm,nsample,mdim)
        endif
        if(interact.eq.1) call zermr(votes,mdim,jbt)

        do nmf=1,nmissfill
!
!       -------------------------------------------------------
!       INITIALIZE FOR RUN
!
        call makea(x,mdim,nsample,cat,isort,v,asave,b,mdimt,&
        msm,v5,v95,maxcat)
!
        call zermr(q,nclass,nsample)
        call zerv(out,nsample)
        if(nprox.gt.0) call zermd(prox,near,nrnn)
        if(ntest.gt.0) then
                call zermr(qts,nclass,ntest)
        endif
!
!       =======================================================
!       **************  BEGIN MAIN LOOP  **********************
!       =======================================================
!
        do jb=1,jbt
!       
!       -------------------------------------------------------
!       INITIALIZE
!       
        call zervr(win,nsample)
        call zerv(jin,nsample)
        call zervr(tclasspop,nclass)
!
!       -------------------------------------------------------
!       TAKE A BOOTSTRAP SAMPLE 
!
        do n=1,nsample
                k=int(randomu()*nsample)
                if(k.lt.nsample) k=k+1
                win(k)=win(k)+classwt(cl(k))
                jin(k)=jin(k)+1
                tclasspop(cl(k))=tclasspop(cl(k))+classwt(cl(k))
        enddo
        do n=1,nsample
                if(jin(n).eq.0) out(n)=out(n)+1
!               out(n)=number of trees for which the nth 
!               obs has been out-of-bag
        enddo
!
!       -------------------------------------------------------
!       PREPARE TO BUILD TREE
!
        call moda(asave,a,nuse,nsample,mdim,cat,maxcat,ncase,&
        jin,mdimt,msm)
!
!       -------------------------------------------------------
!       MAIN TREE-BUILDING 
!
        call buildtree(a,b,cl,cat,mdim,nsample,nclass,treemap,&
       bestvar,bestsplit,bestsplitnext,dgini,nodestatus,nodepop,&
        nodestart,classpop,tclasspop,tclasscat,ta,nrnodes,&
        idmove,ndsize,ncase,parent,mtry,nodeclass,ndbigtree,&
        win,wr,wl,nuse,kcat,ncatsplit,xc,dn,cp,cm,maxcat,&
        nbestcat,msm,mdimt,iseed,ncsplit,ncmax)
!
!       -------------------------------------------------------
!       SPLIT X
!
        call xtranslate(x,mdim,nrnodes,nsample,bestvar,bestsplit,&
        bestsplitnext,xbestsplit,nodestatus,cat,ndbigtree)
!
!       -------------------------------------------------------
!       ASSIGN CLASSWEIGHTS TO NODES
!
        if(jclasswt.eq.1) then
                call getweights(x,nsample,mdim,treemap,nodestatus,&
                xbestsplit,bestvar,nrnodes,ndbigtree,&
                cat,maxcat,nbestcat,jin,win,tw,tn,tnodewt)
        endif
!
!       -------------------------------------------------------
!       GET OUT-OF-BAG ESTIMATES
!
        call testreebag(x,nsample,mdim,treemap,nodestatus,&
        xbestsplit,bestvar,nodeclass,nrnodes,ndbigtree,kpop,&
        cat,jtr,nodextr,maxcat,nbestcat,rpop,dgini,tgini,jin,&
        wtx)
        do n=1,nsample
                if(jin(n).eq.0) then
!               this case is out-of-bag
                q(jtr(n),n)=q(jtr(n),n)+tnodewt(nodextr(n))
                endif
        enddo
        do k=1,mdimt
                m=msm(k)
                avgini(m)=avgini(m)+tgini(m)
                if(interact.eq.1) votes(m,jb)=tgini(m)
        enddo
!       
!       -------------------------------------------------------
!       DO PRE-PROX COMPUTATION
!       
        if(nprox.eq.1) then
                call preprox(near,nrnodes,jbt,nodestatus,ncount,jb,&
                nod,nodextr,nodexb,jin,jinb,ncn,ndbegin,kpop,rinpop,&
                npcase,rpop,nsample)
        endif
!
!       -------------------------------------------------------
!       GET TEST SET ERROR ESTIMATES
!
        if(ntest.gt.0) then
                call testreelite(xts,ntest,mdim,treemap,nodestatus,&
                xbestsplit,bestvar,nodeclass,nrnodes,ndbigtree,&
                cat,jts,maxcat,nbestcat,nodexts)
                do n=1,ntest0
                        qts(jts(n),n)=qts(jts(n),n)+tnodewt(nodexts(n))
                enddo
        endif
!
!       -------------------------------------------------------
!       GIVE RUNNING OUTPUT
!
        if(lookcls.eq.1.and.jb.eq.1) then
                write(*,*) 'class counts-training data'
                write(*,*) (nc(j),j=1,nclass)
                if(ntest.gt.0.and.labelts.eq.1) then
                        print*
                        write(*,*) 'class counts-test data'
                        write(*,*) (ncts(j),j=1,nclass)
                endif
        endif
        if(mod(jb,look).eq.0.or.jb.eq.jbt) then
                call comperrtr(q,cl,nsample,nclass,errtr,&
                tmiss,nc,jest,out)
                if(look.gt.0) then
                if(lookcls.eq.1) then
                        write(*,'(i8,100f10.2)') &
                        jb,100*errtr,(100*tmiss(j),j=1,nclass)
!               else !deleted 26 May 2010
!                       write(*,'(i8,2f10.2)') jb,100*errtr
                endif
                endif
                if(ntest.gt.0) then
                        call comperrts(qts,clts,ntest,nclass,errts,&
                        tmissts,ncts,jests,labelts)
                        if(look.gt.0) then
                        if(labelts.eq.1) then
                           if(lookcls.eq.1) then
                                write(*,'(i8,20f10.2)') jb,100*errts,&
                                (100*tmissts(j),j=1,nclass)
!                          else  !deleted 26 May 2010
!                               write(*,'(i8,2f10.2)') jb,100*errts
                           endif
!ccc                       print *
                           write(*,*)'. ' !28 May 2010
                        endif
                        endif
                endif
        endif
!       
!       -------------------------------------------------------
!       VARIABLE IMPORTANCE 
!
        if(imp.eq.1.and.nmf.eq.nmissfill) then
        call varimp(x,nsample,mdim,cl,nclass,jin,jtr,impn,&
        interact,msm,mdimt,qimp,qimpm,avimp,sqsd,&
        treemap,nodestatus,xbestsplit,bestvar,nodeclass,nrnodes,&
        ndbigtree,cat,jvr,nodexvr,maxcat,nbestcat,tnodewt,&
        nodextr,joob,pjoob,iv)
        endif
!
!       -------------------------------------------------------
!       SEND SAVETREE DATA TO FILE (IF THIS IS THE FINAL FOREST)
!
        if(isaverf.eq.1.and.nmd.eq.ndimreps.and.nmf.eq.nmissfill) then
                if(jb.eq.1) then
                        write(1,*) (cat(m),m=1,mdim)
                        if(missfill.ge.1) write(1,*) (fill(m),m=1,mdim)
                endif
                write(1,*) ndbigtree
                do n=1,ndbigtree
                        write(1,*) n,nodestatus(n),bestvar(n),treemap(1,n),&
                        treemap(2,n),nodeclass(n),xbestsplit(n),tnodewt(n),&
                        (nbestcat(k,n),k=1,maxcat)
                enddo
        endif
        
!       =======================================================
!       **************  END MAIN LOOP  ************************
!       =======================================================
        enddo !jb
!
!       -------------------------------------------------------
!       FIND PROXIMITIES, FILL IN MISSING VALUES AND ITERATE
!
        if(nmf.lt.nmissfill) then
                write(*,*) 'nrep',nmf
                
!               compute proximities between each obs in the training 
!               set and its nrnn closest neighbors
                
                call comprox(prox,nodexb,jinb,ndbegin,&
                npcase,ppr,rinpop,near,jbt,noutlier,outtr,cl,&
                loz,nrnn,wtx,nsample,iwork,ibest)
     
!               use proximities to impute missing values

                call impute(x,prox,near,mdim,&
                maxcat,votecat,cat,nrnn,loz,missing)
        endif
        enddo !nmf
!
!       -------------------------------------------------------
!       COMPUTE IMPORTANCES, SELECT SUBSET AND LOOP BACK
!
        if(imp.eq.1) then
                call finishimp(mdim,sqsd,avimp,signif,&
                zscore,jbt,mdimt,msm)
                do m=1,mdimt
!                       zt(m) is the negative z-score for variable msm(m)
                        zt(m)=-zscore(msm(m))
                        muse(m)=msm(m)
                enddo
!               sort zt from smallest to largest,and sort muse accordingly
                call quicksort(zt,muse,1,mdimt,mdim)
!               muse(m) refers to the variable that has the mth-smallest zt
!               select the mdim2nd most important variables and iterate
                if(mdim2nd.gt.0) then
                        mdimt=mdim2nd
                        do m=1,mdimt
                                msm(m)=muse(m)
                        enddo
                        mtry=nint(sqrt(real(mdimt)))
                endif
        endif
        enddo !nmd
!
!       -------------------------------------------------------
!       END OF ITERATIONS - NOW ENDGAME
!       -------------------------------------------------------
!
!       -------------------------------------------------------
!       NORMALIZE VOTES
!
        do j=1,nclass
                do n=1,nsample
                        if(q(j,n).gt.0.0.and.out(n).gt.0) q(j,n)=q(j,n)/real(out(n))
                enddo
                if(ntest.gt.0) then
                        do n=1,ntest0
                                qts(j,n)=qts(j,n)/jbt
                        enddo
                endif
        enddo
!
!       -------------------------------------------------------
!       COMPUTE PROXIMITIES AND SEND TO FILE
!
        if(nprox.ge.1) then
!               compute proximities between each obs in the training 
!               set and its nrnn closest neighbors
                
                call comprox(prox,nodexb,jinb,ndbegin,&
                npcase,ppr,rinpop,near,jbt,noutlier,outtr,cl,&
                loz,nrnn,wtx,nsample,iwork,ibest)
   
                if(iproxout.ge.1) then 
                        do n=1,near
                                write(13,'(i5,500(i5,f10.3))') n,(loz(n,k),&
                                prox(n,k),k=1,nrnn)
                        enddo
                endif
        endif
        close(13)
!
!       -------------------------------------------------------
!       COMPUTE SCALING COORDINATES AND SEND TO FILE
!
        if(nprox.eq.1.and.nscale.gt.0) then
                call myscale(loz,prox,xsc,y,u,near,nscale,red,nrnn,&
                ee,ev,dl)
                if(iscaleout.eq.1)then
                        do n=1,nscale0
                                write(14,'(i5,f10.3)') n,dl(n)
                        enddo
                        do n=1,near
                                write(14,'(3i5,15f10.3)') n,cl(n),jest(n),&
                                (xsc(n,k),k=1,nscale0)
                        enddo
                        close(14)
                endif
        endif
!
!       -------------------------------------------------------
!       COMPUTE CASEWISE VARIABLE IMPORTANCE (FOR GRAPHICS)
!       AND SEND TO FILE
!
        if(impn.eq.1) then
                do n=1,nsample
                        do m1=1,mdimt
                                mr=msm(m1)
                                qimpm(n,mr)=100*(qimp(n)-qimpm(n,mr))/jbt
                        enddo
                        if(impnout.eq.1) write(10,'(100f10.3)')&
                        (qimpm(n,msm(m1)),m1=1,mdimt)
                enddo
        endif
!
!       -------------------------------------------------------
!       SEND IMPORTANCES TO FILE OR SCREEN
!
        if(imp.eq.1) then
                do k=1,min0(mdimt,25)
                        m=muse(k)
                        if(impout.eq.1) write(9,'(i5,10f10.3)')m,100*avimp(m),&
                        zscore(m),signif(m)
                        if(impout.eq.2) write(*,'(i5,10f10.3)')m,100*avimp(m),&
                        zscore(m),signif(m)
                enddo
                close(9)
        endif
!
!       -------------------------------------------------------
!       COMPUTE INTERACTIONS AND SEND TO FILE OR SCREEN
!
        if(interact.eq.1) then
                call compinteract(votes,effect,msm,mdim,mdimt,&
                jbt,g,iv,irnk,hist,teffect)
                if(interout.eq.1) then
                        write(11,*)'CODE'
                        do i=1,mdimt
                                write(11,*) i,msm(i)
                        enddo
                        print*
                        do i=1,mdimt
                                m=msm(i)
                                effect(m,m)=0
                                write(11,'(40i5)') i,&
                                (nint(effect(m,msm(j))),j=1,mdimt)
                        enddo
                        close(11)
                endif
                if(interout.eq.2) then
                        write(*,*)'CODE'
                        do i=1,mdimt
                                write(*,*) i,msm(i)
                        enddo
                        print*
                        do i=1,mdimt
                                m=msm(i)
                                effect(m,m)=0
                                write(*,'(20i5)') i,&
                                (nint(effect(m,msm(j))),j=1,mdimt)
                        enddo
                endif
        endif
!
!       -------------------------------------------------------
!       COMPUTE FASTIMP AND SEND TO FILE
!
        if(impfastout.eq.1) then
                tavg=0
                do k=1,mdimt
                        m=msm(k)
                        tavg=tavg+avgini(m)
                enddo
                tavg=tavg/mdimt
                do k=1,mdimt
                        m=msm(k)
                        write(8,*) m,avgini(m)/tavg
                enddo
                close(8)
        endif

!       -------------------------------------------------------
!       COMPUTE PROTOTYPES AND SEND TO FILE
!
        if(nprox.ge.1.and.nprot.gt.0) then
                call compprot(loz,nrnn,nsample,mdim,its,&
                cl,wc,nclass,x,mdimt,msm,temp,cat,maxcat,&
                jpur,inear,nprot,protlow,prothigh,prot,protfreq,&
                protvlow,protvhigh,protv,&
                popclass,npend,freq,v5,v95)
!       
                if (iprotout.eq.1) then
                write(12,'(a5,50i10)') '     ',(&
                (nint(popclass(i,j)),i=1,npend(j)),j=1,nclass)
                write(12,'(a5,50i10)') '     ',(&
                (i,i=1,npend(j)),j=1,nclass)
                write(12,'(a5,50i10)') '     ',(&
                (j,i=1,npend(j)),j=1,nclass)
                do k=1,mdimt
                        m=msm(k)
                        if(cat(m).eq.1) then
                                write(12,'(i5,50f10.3)') k,&
                                ((prot(m,i,j),protlow(m,i,j),&
                                prothigh(m,i,j),i=1,npend(j)),j=1,nclass)
                        else 
                                write(12,'(i5,50f10.3)') k,&
                                (((protfreq(m,i,j,jj),jj=1,cat(m)),&
                                i=1,npend(j)),j=1,nclass)
                        endif
                enddo
                endif
                close (12)
!
                if(iprotout.eq.2) then
                write(*,'(a5,50i10)') '     ',((nint(popclass(i,j)),&
                i=1,npend(j)),j=1,nclass)
                do k=1,mdimt
                        m=msm(k)
                        if(cat(m).eq.1) then
                                write(*,'(i5,50f10.3)') k,&
                                ((prot(m,i,j),protlow(m,i,j),&
                                prothigh(m,i,j),i=1,npend(j)),j=1,nclass)
                        else
                                write(*,'(i5,50f10.3)') k,&
                                (((protfreq(m,i,j,jj),jj=1,cat(m)),&
                                i=1,npend(j)),j=1,nclass)
                        endif
                enddo
                endif
        endif
!
!       -------------------------------------------------------
!       COMPUTE OUTLIER MEASURE AND SEND TO FILE
!
        if(noutlier.ge.1) then
                call locateout(cl,tout,outtr,ncp,isort,devout,&
                near,nsample,nclass,rmedout)
                if(ioutlierout.ge.1) then
                        do n=1,near
                                write(15,'(2i5,f10.3)') n,cl(n),&
                                amax1(outtr(n),0.0)
                        enddo
                endif
        endif
!       
!       -------------------------------------------------------
!       SUMMARY OUTPUT
!
!       output to register.txt file (added 26 May 2010):
        LLL=mylen(datatrain)
        KKK=mylen(datatest)
        open(33,file='register.txt',access='append')
            write(33,*)'RandomForest ',datatrain(1:LLL),' ',datatest(1:KKK),' ',nclass,&
            errtr,errts,ntest,int(errts*ntest),';'
        close(33)
!
        if(ROC>0) then
!               output to roc.txt file (added 9 June 2010):
            open(33,file='roc.txt',status='replace')
                write(33,*)'RandFor:',char(9),datatrain(1:LLL),char(9),datatest(1:KKK),char(9),&
                ntest,char(9),nclass,char(9),errtr,char(9),errts
                write(33,*)'  ClassDesired',char(9),'ClassFound',char(9),'probabilities of classes',';'
                
                do n=1,ntest
                    cmax=0  !tento blok hleda pro kazdy vzorek maximum v matici qts, 
!                        tj. max. "vystup" cmax a jeho pozici jmax
                    do j=1,nclass
                        if (qts(j,n).gt.cmax) then
                                jmax=j
                                cmax=qts(j,n)
                        endif
                    enddo ! na konci je v jmax cislo nalezene tridy a v cmax odpovidajici max. pravdepodobnost
                    write(33,*)clts(n),char(9),jmax,char(9),(qts(j,n),char(9),j=1,nclass),';'  ! soll, ist, pravdepodobnosti
                enddo
            close(33)
        endif
!
!
        if (isumout.eq.1) then
                write(*,*) 'final error rate %    ',100*errtr
                if(ntest.gt.0.and.labelts.ne.0)then
                        write(*,*) 'final error test %    ',100*errts 
                endif 
            if(lookcls.eq.1) then !added 26 May 2010
                print *
                write(*,*) 'Training set confusion matrix (OOB):'
            endif
                call zerm(mtab,nclass,nclass)
                do n=1,nsample
                        if(jest(n).gt.0) mtab(cl(n),jest(n))=mtab(cl(n),jest(n))+1
                enddo
            if(lookcls.eq.1) then !added 26 May 2010
                write(*,*) '        true class '
                print *
                write(*,'(20i6)')  (i,i=1,nclass)
                print *
                do j=1,nclass
                        write(*,'(20i6)')  j,(mtab(i,j),i=1,nclass)
                enddo
                print *
            endif
                if(ntest.gt.0.and.labelts.ne.0) then
                   call zerm(mtab,nclass,nclass)
                   do n=1,ntest0
                        mtab(clts(n),jests(n))=mtab(clts(n),jests(n))+1
                   enddo
            if(lookcls.eq.1) then !added 26 May 2010
                   write(*,*) 'Test set confusion matrix:'
                   write(*,*) '     true class '
                   print *
                   write(*,'(20i6)')  (i,i=1,nclass)
                   print *
                   do j=1,nclass
                        write(*,'(20i6)')  j,(mtab(i,j),i=1,nclass)
                   enddo
                   print *
            endif
                endif
        endif
!
!       -------------------------------------------------------
!       SEND INFO ON TRAINING AND/OR TEST SET DATA TO FILE 
!
        if(idataout.ge.1) then
                do n=1,nsample
                        write(7,'(3i5,5000f10.3)') n,cl(n),jest(n),&
                        (q(j,n),j=1,nclass),(x(m,n),m=1,mdim)
                enddo
        endif
        if(idataout.eq.2.and.ntest.gt.0) then
                if(labelts.eq.1) then
                        do n=1,ntest0
                                write(7,'(3i5,1000f10.3)') n,clts(n),jests(n),&
                                (qts(j,n),j=1,nclass),(xts(m,n),m=1,mdim)
                        enddo
                else
                        do n=1,ntest0
                                write(7,'(2i5,1000f10.3)') n,jests(n),&
                                (qts(j,n),j=1,nclass),(xts(m,n),m=1,mdim)
                        enddo
                endif
        endif
        close(7)
!
!       -------------------------------------------------------
!       SEND GRAPHICS INFO TO FILES 
!
        if(iviz.eq.1) then
                do n=1,nsample
                        write(21,'(1000f10.3)') (x(msm(m),n),m=1,mdimt)
                enddo
                do n=1,nsample
                        write(22,'(100f10.3)')(qimpm(n,msm(m1)),m1=1,mdimt)
                enddo
                do n=1,nsample
                        write(23,'(3i5,5000f10.3)') n,cl(n),jest(n),&
                        (q(j,n),j=1,nclass)
                enddo
                write(24,*) nsample,mdimt,nscale,nclass,mdimt,nprot,nrnn
                do n=1,near
                        write(25,'(50f10.3)') (xsc(n,k),k=1,nscale0)
                enddo
                    if (iprotout.eq.1) then
                                do j=1,nclass
                                        do i=1,npend(j)
                                        write(26,'(3i5,5000f10.3)') j,i,1,(protv(msm(m),i,j),m=1,mdimt)
                                        write(26,'(3i5,5000f10.3)') j,i,2,(protvlow(msm(m),i,j),m=1,mdimt)
                                        write(26,'(3i5,5000f10.3)') j,i,3,(protvhigh(msm(m),i,j),m=1,mdimt)
                                        write(27,'(i5)') nint(popclass(i,j))
                                enddo
                                enddo
                endif
                if(interact.eq.1) then
                        do i=1,mdimt
                                m=msm(i)
                                effect(m,m)=0
                                write(28,'(40i5)')&
                                (nint(effect(m,msm(j))),j=1,mdimt)
                        enddo
                endif
                if(iproxout.ge.1) then 
                        do n=1,nsample
!                               write(29,'(5000(i5,f10.3))') (loz(n,k),prox(n,k),k=1,nrnn)
!                               NEW???:
                                write(29,'(5000(i5,f10.3))') (k,prox(n,k),k=1,nrnn)
                        enddo
                endif
        endif
!
!       -------------------------------------------------------
!       SEND FILL TO FILE (ROUGH FILL ONLY)
!
        if(isavefill.eq.1.and.missfill.eq.1) then
                write(3,*) (fill(m),m=1,mdim)
        endif
!
!       -------------------------------------------------------
!       SEND RUN PARAMETERS TO FILE 
!
        if(isavepar.eq.1) then
                write(2,*) ntrain,mdim,maxcat,nclass,jbt,&
                jclasswt,missfill,code,nrnodes,&
                100*errtr
!
!               type in comments up to 500 characters long
!               between the ' ' in the line below.
!
                write(2,*) 'this is a test run to verify that my &
                &descriptive output works.'
                close (2)
        endif
!
!       -------------------------------------------------------
!       END OF USUAL RUN
!
!
!       -------------------------------------------------------
!       READ RUN PARAMETERS AND PRINT TO SCREEN
!
888     if(ireadpar.eq.1) then
                read(2,*) n0,n1,n2,n3,n4,n5,n6,n7,er
                write(*,*) 'parameters'
                write(*,*) 'nsample=' ,n0
                write(*,*) 'mdim= ' ,n1
                write(*,*) 'maxcat=',n2
                write(*,*) 'nclass=',n3
                write(*,*) 'jbt=  ' ,n4
                write(*,*) 'jclasswt=',n5
                write(*,*) 'code='    ,n6
                write(*,*) 'nrnodes=' ,n7
                print *
                write(*,*) 'out-of-bag error=',er,'%'
                print *
                read(2,'(500a)') text
                write(*,*) text
!
                stop
!
        endif
!
!       -------------------------------------------------------
!       RERUN OLD RANDOM FOREST
!
999     if(irunrf.eq.1.and.ntest.gt.0) then
                call runforest(mdim,ntest,nclass,maxcat,nrnodes,&
                labelts,jbt,clts,xts,xbestsplit,qts,treemap,nbestcat,&
                nodestatus,cat,nodeclass,jts,jests,bestvar,tmissts,ncts,&
                fill,missfill,code,errts,tnodewt,outts,idataout,imax,&
                look,lookcls,nodexts,isumout,mtab) 
        endif
!
!       =======================================================
!       **************  END MAIN2 *****************************
!       =======================================================
!
        return
        end
!
!
!
!
!
!
!       =======================================================
!       **************  SUBROUTINES AND FUNCTIONS  ************
!       =======================================================
!
!       -------------------------------------------------------
        subroutine runforest(mdim,ntest,nclass,maxcat,nrnodes,&
        labelts,jbt,clts,xts,xbestsplit,qts,treemap,nbestcat,&
        nodestatus,cat,nodeclass,jts,jests,bestvar,tmissts,ncts,&
        fill,missfill,code,errts,tnodewt,outts,idataout,imax,&
        look,lookcls,nodexts,isumout,mtab)
!
!       reads a forest file and runs new data through it
!
        real xts(mdim,ntest),xbestsplit(nrnodes),tmissts(nclass),&
        qts(nclass,ntest),fill(mdim),tnodewt(nrnodes),outts(ntest)
!
        integer treemap(2,nrnodes),nodestatus(nrnodes),&
        cat(mdim),nodeclass(nrnodes),jests(ntest),&
        bestvar(nrnodes),jts(ntest),clts(ntest),nodexts(nrnodes),&
        ncts(nclass),imax(ntest),nbestcat(maxcat,nrnodes),&
        isumout,mtab(nclass,nclass)

!
        integer mdim,ntest,nclass,maxcat,nrnodes,labelts,&
        jbt,missfill,look,lookcls,idataout
        real errts,code
        integer m,j,n,jb,ndbigtree,idummy
        call zermr(qts,nclass,ntest)
!
        read(1,*) (cat(m),m=1,mdim)
!
        if(missfill.eq.1) then
                read(1,*) (fill(m),m=1,mdim)
!               fast fix on the test data -
                call xfill(xts,ntest,mdim,fill,code)
        endif
!
        if(labelts.eq.1) then
                do n=1,ntest
                        ncts(clts(n))=ncts(clts(n))+1
                enddo
        endif
!
!       START DOWN FOREST
!
        do jb=1,jbt
                read(1,*) ndbigtree
                do n=1,ndbigtree
                        read(1,*) idummy,nodestatus(n),bestvar(n),&
                        treemap(1,n),treemap(2,n),nodeclass(n),&
                        xbestsplit(n),tnodewt(n),(nbestcat(j,n),j=1,maxcat)
                enddo
                
                call testreelite(xts,ntest,mdim,treemap,nodestatus,&
                xbestsplit,bestvar,nodeclass,nrnodes,ndbigtree,&
                cat,jts,maxcat,nbestcat,nodexts)
                do n=1,ntest
                        qts(jts(n),n)=qts(jts(n),n)+tnodewt(nodexts(n))
                enddo
                
                if(labelts.eq.1) then
                        if(mod(jb,look).eq.0.and.jb.le.jbt) then
                                call comperrts(qts,clts,ntest,nclass,errts,&
                                tmissts,ncts,jests,labelts)
                                if(lookcls.eq.1) then
                                        write(*,'(i8,100f10.2)') &
                                        jb,100*errts,(100*tmissts(j),j=1,nclass)
                                else
                                        write(*,'(i8,2f10.2)') jb,100*errts
                                endif
                        endif
                endif
!
        enddo !jb
!
        if(idataout.eq.2) then
                if(labelts.eq.1) then
                        do n=1,ntest
                                write(7,'(3i5,1000f10.3)') n,clts(n),jests(n),&
                                (qts(j,n),j=1,nclass),(xts(m,n),m=1,mdim)
                        enddo
                else
                        do n=1,ntest
                                write(7,'(3i5,1000f10.3)') n,jests(n),&
                                (qts(j,n),j=1,nclass),(xts(m,n),m=1,mdim)
                        enddo
                endif
        endif
        close(7)
        if (isumout.eq.1) then
                if(labelts.eq.1)then
                   write(*,*) 'final error test %    ',100*errts 
                   call zerm(mtab,nclass,nclass)
                   do n=1,ntest
                        mtab(clts(n),jests(n))=mtab(clts(n),jests(n))+1
                   enddo
                   write(*,*) 'Test set confusion matrix:'
                   write(*,*) '     true class '
                   print *
                   write(*,'(20i6)')  (j,j=1,nclass)
                   print *
                   do n=1,nclass
                        write(*,'(20i6)')  n,(mtab(j,n),j=1,nclass)
                   enddo
                   print *
                endif
        endif
        end
!
!       -------------------------------------------------------
        subroutine makea(x,mdim,nsample,cat,isort,v,asave,b,mdimt,&
        msm,v5,v95,maxcat)
!
        real x(mdim,nsample),v(nsample),v5(mdim),v95(mdim)
        integer cat(mdim),isort(nsample),asave(mdim,nsample),&
        b(mdim,nsample),msm(mdim)
        integer mdim,nsample,mdimt,maxcat
        integer k,mvar,n,n1,n2,ncat,jj
!
!       submakea constructs the mdim x nsample integer array a.
!       If there are less than 32,000 cases, this can be declared 
!       integer*2,otherwise integer*4. For each numerical variable 
!       with values x(m,n),n=1,...,nsample, the x-values are sorted 
!       from lowest to highest. Denote these by xs(m,n). 
!       Then asave(m,n) is the case  number in which 
!       xs(m,n) occurs. The b matrix is also constructed here. If the mth 
!       variable is categorical, then asave(m,n) is the category of the nth 
!       case number.  
!
!       input: x,cat
!       output: a,b
!       work: v,isort
!
        do k=1,mdimt
          mvar=msm(k)
          if (cat(mvar).eq.1) then
                do n=1,nsample
                        v(n)=x(mvar,n)
                        isort(n)=n
                enddo
                call quicksort(v,isort,1,nsample,nsample)
!               this sorts the v(n) in ascending order. isort(n) is the 
!               case number of that v(n) nth from the lowest (assume 
!               the original case numbers are 1,2,...).  
                n1=nint(.05*nsample)
                if(n1.lt.1) n1=1
                v5(mvar)=v(n1)
                n2=nint(.95*nsample)
                if(n2.gt.nsample) n2=nsample
                v95(mvar)=v(n2)
                do n=1,nsample-1
                        n1=isort(n)
                        n2=isort(n+1)
                        asave(mvar,n)=n1
                        if(n.eq.1) b(mvar,n1)=1
                        if (v(n).lt.v(n+1)) then
                                b(mvar,n2)=b(mvar,n1)+1
                        else
                                b(mvar,n2)=b(mvar,n1)
                        endif
                enddo
                asave(mvar,nsample)=isort(nsample)
          else
                do ncat=1,nsample
                        jj=nint(x(mvar,ncat))
                        asave(mvar,ncat)=jj
                enddo
          endif
        enddo
!
        end
!
!       -------------------------------------------------------
        subroutine moda(asave,a,nuse,nsample,mdim,cat,maxcat,&
        ncase,jin,mdimt,msm)
!
        integer asave(mdim,nsample),a(mdim,nsample),cat(mdim),&
        jin(nsample),ncase(nsample),msm(mdim)
        integer nuse,nsample,mdim,mdimt,maxcat
        integer n,jj,m,k,nt,j
!
!       copy rows msm(1),...,msm(mdimt) of asave into the same 
!       rows of a
!
        nuse=0
        do n=1,nsample
                do k=1,mdimt
                        m=msm(k)
                        a(m,n)=asave(m,n)
                enddo
                if(jin(n).ge.1) nuse=nuse+1
        enddo
        do jj=1,mdimt
                m=msm(jj)
                k=1
                nt=1
                if(cat(m).eq.1) then
                        do n=1,nsample
                        if(k.gt.nsample) goto 37
                            if(jin(a(m,k)).ge.1) then
                                        a(m,nt)=a(m,k)
                                        k=k+1
                                else
                                        do j=1,nsample-k
                                                if(jin(a(m,k+j)).ge.1) then
                                                        a(m,nt)=a(m,k+j)
                                                        k=k+j+1
                                                        goto 28
                                                endif
                                        enddo
                                endif
28                              continue
                                nt=nt+1
                                if(nt.gt.nuse) goto 37
                        enddo
37                      continue
                endif
        enddo
        if(maxcat.gt.1) then
                k=1
                nt=1
                do n=1,nsample
                        if(jin(k).ge.1) then
                                ncase(nt)=k
                                k=k+1
                        else
                                do jj=1,nsample-k
                                        if(jin(k+jj).ge.1) then
                                                ncase(nt)=k+jj
                                                k=k+jj+1
                                                goto 58
                                        endif
                                enddo
                        endif
58                      continue
                        nt=nt+1
                        if(nt.gt.nuse) goto 85
                enddo
85              continue
        endif
        end
!
!       -------------------------------------------------------
        subroutine buildtree(a,b,cl,cat,mdim,nsample,nclass,treemap,&
        bestvar,bestsplit,bestsplitnext,dgini,nodestatus,nodepop,&
        nodestart,classpop,tclasspop,tclasscat,ta,nrnodes,&
        idmove,ndsize,ncase,parent,mtry,nodeclass,ndbigtree,&
        win,wr,wl,nuse,kcat,ncatsplit,xc,dn,cp,cm,maxcat,&
        nbestcat,msm,mdimt,iseed,ncsplit,ncmax)
!
!       Buildtree consists of repeated calls to findbestsplit and movedata.
!       Findbestsplit does just that--it finds the best split of the current 
!       node. Movedata moves the data in the split node right and left so 
!       that the data corresponding to each child node is contiguous.  
!
!       The buildtree bookkeeping is different from that in Friedman's 
!       original CART program: 
!               ncur is the total number of nodes to date
!               nodestatus(k)=1 if the kth node has been split.
!               nodestatus(k)=2 if the node exists but has not yet been split
!                         and=-1 of the node is terminal.  
!       A node is terminal if its size is below a threshold value, or if it 
!       is all one class,or if all the x-values are equal. If the current 
!       node k is split,then its children are numbered ncur+1 (left), and 
!       ncur+2(right),ncur increases to ncur+2 and the next node to be split 
!       is numbered k+1. When no more nodes can be split,buildtree
!       returns to the main program.
!
        integer cl(nsample),cat(mdim),ncatsplit(maxcat),&
        treemap(2,nrnodes),bestvar(nrnodes),nodeclass(nrnodes),&
        bestsplit(nrnodes),nodestatus(nrnodes),ta(nsample),&
        nodepop(nrnodes),nodestart(nrnodes),idmove(nsample),&
        bestsplitnext(nrnodes),ncase(nsample),parent(nrnodes),&
        kcat(maxcat),msm(mdim),iseed,ncsplit,ncmax
        
        integer a(mdim,nsample),b(mdim,nsample)
        real tclasspop(nclass),classpop(nclass,nrnodes),&
        tclasscat(nclass,maxcat),win(nsample),wr(nclass),&
        wl(nclass),dgini(nrnodes),xc(maxcat),dn(maxcat),&
        cp(maxcat),cm(maxcat)
        integer mdim,nsample,nclass,nrnodes,ndsize,&
        mtry,ndbigtree,nuse,maxcat,mdimt,j,ncur,&
        kbuild,ndstart,ndend,jstat
        integer msplit,nbest
        integer lcat,i,kn,k,n,ndendl,nc
        real decsplit,popt1,popt2,pp
        integer nbestcat(maxcat,nrnodes)
!
        call zerv(nodestatus,nrnodes)
        call zerv(nodestart,nrnodes)
        call zerv(nodepop,nrnodes)
        call zermr(classpop,nclass,nrnodes)
        call zerm(treemap,2,nrnodes)
        call zerm(nbestcat,maxcat,nrnodes)
        do j=1,nclass
                classpop(j,1)=tclasspop(j)
        enddo
!
        ncur=1
        nodestart(1)=1
        nodepop(1)=nuse
        nodestatus(1)=2
!       start main loop
!
        do 30 kbuild=1,nrnodes
                if (kbuild.gt.ncur) goto 50
                if (nodestatus(kbuild).ne.2) goto 30
!               initialize for next call to findbestsplit
!
                ndstart=nodestart(kbuild)
                ndend=ndstart+nodepop(kbuild)-1
                do j=1,nclass
                        tclasspop(j)=classpop(j,kbuild)
                enddo
                jstat=0
!                       
                call findbestsplit(a,b,cl,mdim,nsample,nclass,cat,&
                ndstart,ndend,tclasspop,tclasscat,msplit,decsplit,nbest,&
                ncase,jstat,mtry,win,wr,wl,kcat,ncatsplit,xc,dn,&
                cp,cm,maxcat,msm,mdimt,iseed,ncsplit,ncmax)
!
                if(jstat.eq.1) then
                        nodestatus(kbuild)=-1
                        goto 30
                else
                        bestvar(kbuild)=msplit
                        dgini(kbuild)=decsplit
!                       
                        if (cat(msplit).eq.1) then
!                               continuous
                                bestsplit(kbuild)=a(msplit,nbest)
                                bestsplitnext(kbuild)=a(msplit,nbest+1)
                        else
!                               categorical
                                lcat=cat(msplit)
                                do i=1,lcat
                                        nbestcat(i,kbuild)=ncatsplit(i)
                                enddo
                        endif
                endif
                call movedata(a,ta,mdim,nsample,ndstart,ndend,idmove,ncase,&
                msplit,cat,nbest,ndendl,ncatsplit,maxcat,mdimt,msm)
!
!               leftnode no.=ncur+1,rightnode no.=ncur+2.
!
                nodepop(ncur+1)=ndendl-ndstart+1
                nodepop(ncur+2)=ndend-ndendl
                nodestart(ncur+1)=ndstart
                nodestart(ncur+2)=ndendl+1
!
!
!               find class populations in both nodes
                do n=ndstart,ndendl
                        nc=ncase(n)
                        j=cl(nc)
                        classpop(j,ncur+1)=classpop(j,ncur+1)+win(nc)
                enddo
                do n=ndendl+1,ndend
                        nc=ncase(n)
                        j=cl(nc)
                        classpop(j,ncur+2)=classpop(j,ncur+2)+win(nc)
                enddo
!
!               check on nodestatus
!
                nodestatus(ncur+1)=2
                nodestatus(ncur+2)=2
                if (nodepop(ncur+1).le.ndsize) nodestatus(ncur+1)=-1
                if (nodepop(ncur+2).le.ndsize) nodestatus(ncur+2)=-1
                popt1=0
                popt2=0
                do j=1,nclass
                        popt1=popt1+classpop(j,ncur+1)
                        popt2=popt2+classpop(j,ncur+2)
                enddo
                do j=1,nclass
                        if (abs(classpop(j,ncur+1)-popt1)&
                         .lt.8.232D-11) nodestatus(ncur+1)=-1
                        if (abs(classpop(j,ncur+2)-popt2)&
                         .lt.8.232D-11) nodestatus(ncur+2)=-1
                enddo
                treemap(1,kbuild)=ncur+1
                treemap(2,kbuild)=ncur+2
                parent(ncur+1)=kbuild
                parent(ncur+2)=kbuild
                nodestatus(kbuild)=1
                ncur=ncur+2
                if (ncur.ge.nrnodes) goto 50
30      continue
50      continue
        ndbigtree=nrnodes
        do k=nrnodes,1,-1
                if (nodestatus(k).eq.0) ndbigtree=ndbigtree-1
                if (nodestatus(k).eq.2) nodestatus(k)=-1
        enddo
        do kn=1,ndbigtree
                if(nodestatus(kn).eq.-1) then
                        pp=0
                        do j=1,nclass
                                if(classpop(j,kn).gt.pp) then
                                        nodeclass(kn)=j
                                        pp=classpop(j,kn)
                                endif
                        enddo
                endif
        enddo
        end
!
!       -------------------------------------------------------
        subroutine findbestsplit(a,b,cl,mdim,nsample,nclass,cat,&
        ndstart,ndend,tclasspop,tclasscat,msplit,decsplit,nbest,&
        ncase,jstat,mtry,win,wr,wl,kcat,ncatsplit,xc,dn,&
        cp,cm,maxcat,msm,mdimt,iseed,ncsplit,ncmax)
!
!       For the best split,msplit is the variable split on. decsplit is the dec. in impurity.
!       If msplit is numerical,nsplit is the case number of value of msplit split on,
!       and nsplitnext is the case number of the next larger value of msplit.  If msplit is
!       categorical,then nsplit is the coding into an integer of the categories going left.
!
        integer a(mdim,nsample),b(mdim,nsample),iseed,ncsplit,ncmax
!
        integer cl(nsample),cat(mdim),ncase(nsample),msm(mdim),&
        kcat(maxcat),ncatsplit(maxcat),icat(32)
!
        integer mdim,nsample,nclass,ndstart,ndend,mdimt,mtry,&
        msplit,nbest,jstat,maxcat,i,j,k,mv,mvar,nc,&
        lcat,nnz,nhit,ncatsp,nsp
!
        real tclasspop(nclass),tclasscat(nclass,maxcat),&
        win(nsample),wr(nclass),wl(nclass),xc(maxcat),&
        dn(maxcat),cp(maxcat),cm(maxcat)
!
        real decsplit,pno,pdo,rrn,rrd,rln,rld,u,&
        crit0,critmax,crit,su
!
        real randomu
!
        external unpack
!
!       compute initial values of numerator and denominator of Gini
        pno=0
        pdo=0
        do j=1,nclass
                pno=pno+tclasspop(j)*tclasspop(j)
                pdo=pdo+tclasspop(j)
        enddo
        crit0=pno/pdo
        jstat=0
!       start main loop through variables to find best split
        critmax=-1.0e20
!       
        do 20 mv=1,mtry
                k=int(mdimt*randomu())+1
                mvar=msm(k)
                    if(cat(mvar).eq.1) then
!                       it's not a categorical variable:                
                        rrn=pno
                        rrd=pdo
                        rln=0
                        rld=0
                        call zervr(wl,nclass)
                        do j=1,nclass
                                wr(j)=tclasspop(j)
                        enddo
                        do nsp=ndstart,ndend-1
                                nc=a(mvar,nsp)
                                u=win(nc)
                                k=cl(nc)
                                rln=rln+u*(2*wl(k)+u)
                                rrn=rrn+u*(-2*wr(k)+u)
                                rld=rld+u
                                rrd=rrd-u
                                wl(k)=wl(k)+u
                                wr(k)=wr(k)-u
                                if (b(mvar,nc).lt.b(mvar,a(mvar,nsp+1))) then
                                        if(amin1(rrd,rld).gt.1.0e-5) then
                                                crit=(rln/rld)+(rrn/rrd)
                                                if (crit.gt.critmax) then
                                                        nbest=nsp
                                                        critmax=crit
                                                        msplit=mvar
                                                        
                                                endif
                                        endif
                                endif
                        enddo
                        
                else
!                       it's a categorical variable:            
!                       compute the decrease in impurity given by categorical splits
                        lcat=cat(mvar)
                        call zermr(tclasscat,nclass,maxcat)
                        do nsp=ndstart,ndend
                                nc=ncase(nsp)
                                k=a(mvar,ncase(nsp))
                                tclasscat(cl(nc),k)=tclasscat(cl(nc),k)+win(nc)
                        enddo
                        nnz=0
                        do i=1,lcat
                                su=0
                                do j=1,nclass
                                        su=su+tclasscat(j,i)
                                enddo
                                dn(i)=su
                                nnz=nnz+1
                        enddo
                        if (nnz.eq.1) then
                                critmax=-1.0e25
                                goto 20
                        endif
                        if(lcat.lt.ncmax) then
                                call catmax(pdo,tclasscat,tclasspop,nclass,lcat,&
                                ncatsp,critmax,nhit,maxcat)
                                if(nhit.eq.1) then
                                        msplit=mvar
                                        call unpack(lcat,ncatsp,icat)
                                        call zerv(ncatsplit,maxcat)
                                        do k=1,lcat
                                                ncatsplit(k)=icat(k)
                                        enddo
                                endif
                        else 
                                call catmaxr(ncsplit,tclasscat,tclasspop,icat,&
                                nclass,lcat,maxcat,ncatsplit,critmax,pdo,nhit,&
                                iseed)
                                if(nhit.eq.1)then
                                        msplit=mvar
                                endif
                        endif
                endif !cat
20      continue
25      continue
        decsplit=critmax-crit0
        if (critmax.lt.-1.0e10) jstat=1
        end
!
!       -------------------------------------------------------
        subroutine catmaxr(ncsplit,tclasscat,tclasspop,icat,&
        nclass,lcat,maxcat,ncatsplit,critmax,pdo,nhit,iseed)
!
!       this routine takes the best of ncsplit random splits
!
        real tclasscat(nclass,maxcat),tclasspop(nclass),tmpclass(100)
        real critmax,pdo
        integer icat(32),iseed
        integer ncsplit,nclass,lcat,maxcat,ncatsplit(maxcat),nhit
!
        integer irbit
        real pln,pld,prn,tdec
        integer j,n,i,k
!
        nhit=0
        do n=1,ncsplit
!               generate random split
                do k=1,lcat
                        icat(k)=irbit(iseed)    !icat(k) is bernouilli
                enddo
                do j=1,nclass
                        tmpclass(j)=0
                        do k=1,lcat
                                if(icat(k).eq.1) then
                                        tmpclass(j)=tmpclass(j)+tclasscat(j,k)
                                endif
                        enddo
                enddo
                pln=0
                pld=0
                do j=1,nclass
                        pln=pln+tmpclass(j)*tmpclass(j)
                        pld=pld+tmpclass(j)
                enddo
                prn=0
                do j=1,nclass
                        tmpclass(j)=tclasspop(j)-tmpclass(j)
                        prn=prn+tmpclass(j)*tmpclass(j)
                enddo
                tdec=(pln/pld)+(prn/(pdo-pld))
                if (tdec.gt.critmax) then
                        critmax=tdec
                        nhit=1
                        do k=1,lcat
                                ncatsplit(k)=icat(k)
                        enddo
                endif
        enddo
        end
!
!       -------------------------------------------------------
        subroutine catmax(pdo,tclasscat,tclasspop,nclass,lcat,&
        ncatsp,critmax,nhit,maxcat)
!
!       this finds the best split of a categorical variable
!       with lcat categories and nclass classes, where 
!       tclasscat(j,k) is the number of cases in
!       class j with category value k. The method uses an 
!       exhaustive search over all partitions of the category 
!       values. For the two class problem,there is a faster 
!       exact algorithm. If lcat.ge.10,the exhaustive search
!       gets slow and there is a faster iterative algorithm.
        real tclasscat(nclass,maxcat),tclasspop(nclass),tmpclass(100)
        integer icat(32),n,lcat,nhit,l,j,ncatsp,nclass,maxcat
        real critmax,pdo,pln,pld,prn,tdec
!
        external unpack
        nhit=0
        do n=1,(2**(lcat-1))-1
                call unpack(lcat,n,icat)
                do j=1,nclass
                        tmpclass(j)=0
                        do l=1,lcat
                                if(icat(l).eq.1) then
                                        tmpclass(j)=tmpclass(j)+tclasscat(j,l)
                                endif
                        enddo
                enddo
                pln=0
                pld=0
                do j=1,nclass
                        pln=pln+tmpclass(j)*tmpclass(j)
                        pld=pld+tmpclass(j)
                enddo
                prn=0
                do j=1,nclass
                        tmpclass(j)=tclasspop(j)-tmpclass(j)
                        prn=prn+tmpclass(j)*tmpclass(j)
                enddo
                tdec=(pln/pld)+(prn/(pdo-pld))
                if (tdec.gt.critmax) then
                        critmax=tdec
                        ncatsp=n
                        nhit=1
                endif
        enddo
        end
!
!       -------------------------------------------------------
        subroutine movedata(a,ta,mdim,nsample,ndstart,ndend,idmove,&
        ncase,msplit,cat,nbest,ndendl,ncatsplit,maxcat,mdimt,msm)
!
!       movedata is the heart of the buildtree construction. 
!       Based on the best split the data corresponding to the 
!       current node is moved to the left if it belongs to the 
!       left child and right if it belongs to the right child.
        integer a(mdim,nsample),ta(nsample),idmove(nsample),&
        ncase(ndend),cat(mdim),ncatsplit(maxcat),msm(mdimt)
        integer mdim,ndstart,ndend,nsample,msplit,nbest,ndendl
        integer maxcat,mdimt,nsp,nc,ms,msh,k,n,ih
!       compute idmove=indicator of case nos. going left
!
        if (cat(msplit).eq.1) then
                do nsp=ndstart,nbest
                        nc=a(msplit,nsp)
                        idmove(nc)=1
                enddo
                do nsp=nbest+1,ndend
                        nc=a(msplit,nsp)
                        idmove(nc)=0
                enddo
                ndendl=nbest
        else
                ndendl=ndstart-1
                do nsp=ndstart,ndend
                        nc=ncase(nsp)
                        if (ncatsplit(a(msplit,nc)).eq.1) then
                                idmove(nc)=1
                                ndendl=ndendl+1
                        else
                                idmove(nc)=0
                        endif
                enddo
        endif
        
!        shift case. nos. right and left for numerical variables.       
        
        do ms=1,mdimt
                msh=msm(ms)
                if (cat(msh).eq.1) then
                        k=ndstart-1
                        do n=ndstart,ndend
                                ih=a(msh,n)
                                if (idmove(ih).eq.1) then
                                        k=k+1
                                        ta(k)=a(msh,n)
                                endif
                        enddo
                        do n=ndstart,ndend
                                ih=a(msh,n)
                                if (idmove(ih).eq.0) then 
                                        k=k+1
                                        ta(k)=a(msh,n)
                                endif
                        enddo
                        do k=ndstart,ndend
                                a(msh,k)=ta(k)
                        enddo
                endif
        enddo

!        compute case nos. for right and left nodes.
        
        if (cat(msplit).eq.1) then
                do n=ndstart,ndend
                        ncase(n)=a(msplit,n)
                enddo
        else
                k=ndstart-1
                do n=ndstart,ndend
                        if (idmove(ncase(n)).eq.1) then
                                k=k+1
                                ta(k)=ncase(n)
                        endif
                enddo
                do n=ndstart,ndend
                        if (idmove(ncase(n)).eq.0) then
                                k=k+1
                                ta(k)=ncase(n)
                        endif
                enddo
                do k=ndstart,ndend
                        ncase(k)=ta(k)
                enddo
        endif
        end

!
!       -------------------------------------------------------
        subroutine xtranslate(x,mdim,nrnodes,nsample,bestvar,&
        bestsplit,bestsplitnext,xbestsplit,nodestatus,cat,&
        ndbigtree)
!
!       xtranslate takes the splits on numerical variables and translates them
!       back into x-values.  It also unpacks each categorical split into a 32-
!       dimensional vector with components of zero or one--a one indicates 
!       that the corresponding category goes left in the split.
!
        integer cat(mdim),bestvar(nrnodes),bestsplitnext(nrnodes),&
        nodestatus(nrnodes),bestsplit(nrnodes)
        real x(mdim,nsample),xbestsplit(nrnodes)
        integer mdim,nrnodes,nsample,ndbigtree,k,m
!
        do k=1,ndbigtree
                if (nodestatus(k).eq.1) then
                        m=bestvar(k)
                        if (cat(m).eq.1) then
                                xbestsplit(k)=(x(m,bestsplit(k))+&
                                x(m,bestsplitnext(k)))/2
                        else
                                xbestsplit(k)=real(bestsplit(k))
                        endif
                endif
        enddo
        end
!
!       -------------------------------------------------------
        subroutine getweights(x,nsample,mdim,treemap,nodestatus,&
        xbestsplit,bestvar,nrnodes,ndbigtree,&
        cat,maxcat,nbestcat,jin,win,tw,tn,tnodewt)
!
        real x(mdim,nsample),xbestsplit(nrnodes),&
        win(nsample),tw(ndbigtree),tn(ndbigtree),tnodewt(ndbigtree)
        integer nsample,mdim,nrnodes,ndbigtree,maxcat
        integer treemap(2,nrnodes),bestvar(nrnodes),&
        cat(mdim),nodestatus(nrnodes),jin(nsample)
!
        integer nbestcat(maxcat,nrnodes)
        integer jcat,n,kt,k,m
        call zervr(tw,ndbigtree)
        call zervr(tn,ndbigtree)
        do n=1,nsample
                if(jin(n).ge.1) then
                        kt=1
                        do k=1,ndbigtree
                                if (nodestatus(kt).eq.-1) then
                                        tw(kt)=tw(kt)+win(n)
                                        tn(kt)=tn(kt)+jin(n)
                                        goto 100
                                endif
                                m=bestvar(kt)
                                if (cat(m).eq.1) then
                                        if (x(m,n).le.xbestsplit(kt)) then 
                                                kt=treemap(1,kt)
                                        else
                                                kt=treemap(2,kt)
                                        endif
                                else
                                        jcat=nint(x(m,n))
                                        if (nbestcat(jcat,kt).eq.1) then
                                                kt=treemap(1,kt)
                                        else
                                                kt=treemap(2,kt)
                                        endif
                                endif
                        enddo
100                     continue
                endif
        enddo
        do n=1,ndbigtree
                if(nodestatus(n).eq.-1) tnodewt(n)=tw(n)/tn(n)
        enddo
        end
!
!       -------------------------------------------------------
        subroutine testreebag(x,nsample,mdim,treemap,nodestatus,&
        xbestsplit,bestvar,nodeclass,nrnodes,ndbigtree,kpop,&
        cat,jtr,nodextr,maxcat,nbestcat,rpop,dgini,tgini,jin,&
        wtx)
!
!       predicts the class of all objects in x
!
!       input:
        real x(mdim,nsample),xbestsplit(nrnodes),dgini(nrnodes),&
        rpop(nrnodes),wtx(nsample)
        integer treemap(2,nrnodes),bestvar(nrnodes),&
        nodeclass(nrnodes),cat(mdim),nodestatus(nrnodes),&
        nbestcat(maxcat,nrnodes),jin(nsample),kpop(nrnodes)
!
        integer nsample,mdim,nrnodes,ndbigtree,maxcat
!
!       output:
        real tgini(mdim)
        integer jtr(nsample),nodextr(nsample)
!
!       local
        integer n,kt,k,m,jcat
!
        call zerv(jtr,nsample)
        call zerv(nodextr,nsample)
        call zervr(tgini,mdim)
        call zervr(rpop,nrnodes)
        call zerv(kpop,nrnodes)
!
        n=1
903     kt=1
        do k=1,ndbigtree
                if (nodestatus(kt).eq.-1) then
                        jtr(n)=nodeclass(kt)
                        nodextr(n)=kt
                        if(jin(n).gt.0)then
                        rpop(kt)=rpop(kt)+jin(n)
                        kpop(kt)=kpop(kt)+1
                        endif
                        goto 100
                endif
                m=bestvar(kt)
                tgini(m)=tgini(m)+dgini(kt)
                if (cat(m).eq.1) then
                        if (x(m,n).le.xbestsplit(kt)) then 
                                kt=treemap(1,kt)
                        else
                                kt=treemap(2,kt)
                        endif
                endif
                if(cat(m).gt.1) then
                        jcat=nint(x(m,n))
                        if (nbestcat(jcat,kt).eq.1) then
                                kt=treemap(1,kt)
                        else
                                kt=treemap(2,kt)
                        endif
                endif
        enddo !k
100     n=n+1
        if(n.le.nsample) goto 903
        
        do m=1,mdim
                tgini(m)=tgini(m)/nsample
        enddo
        
        end
!       
!       -------------------------------------------------------
        subroutine testreelite(xts,ntest,mdim,treemap,nodestatus,&
        xbestsplit,bestvar,nodeclass,nrnodes,ndbigtree,&
        cat,jts,maxcat,nbestcat,nodexts)
!
!       predicts the class of all objects in xts
!
!       input:
        real xts(mdim,ntest),xbestsplit(nrnodes)
        integer treemap(2,nrnodes),bestvar(nrnodes),nodeclass(nrnodes),&
        cat(mdim),nodestatus(nrnodes),nbestcat(maxcat,nrnodes)
        integer ntest,mdim,nrnodes,ndbigtree,maxcat
!
!       output: 
        integer jts(ntest),nodexts(ntest)
!
        integer n,kt,k,m,jcat
!
        n=1
903     kt=1
        do k=1,ndbigtree
                if (nodestatus(kt).eq.-1) then
                        jts(n)=nodeclass(kt)
                        nodexts(n)=kt
                        goto 100
                endif
                m=bestvar(kt)
                if (cat(m).eq.1) then
                        if (xts(m,n).le.xbestsplit(kt)) then 
                                kt=treemap(1,kt)
                        else
                                kt=treemap(2,kt)
                        endif
                endif
                if(cat(m).gt.1) then
                        jcat=nint(xts(m,n))
                        if (nbestcat(jcat,kt).eq.1) then
                                kt=treemap(1,kt)
                        else
                                kt=treemap(2,kt)
                        endif
                endif
        enddo !k
100     n=n+1
        if(n.le.ntest) goto 903
        end
!
!       -------------------------------------------------------
        subroutine testreeimp(x,nsample,mdim,joob,pjoob,nout,mr,&
        treemap,nodestatus,xbestsplit,bestvar,nodeclass,nrnodes,&
        ndbigtree,cat,jvr,nodexvr,maxcat,nbestcat)
!
!       predicts the class of out-of-bag-cases for variable importance
!       also computes nodexvr
!
!       input:
        real x(mdim,nsample),xbestsplit(nrnodes)
        integer treemap(2,nrnodes),bestvar(nrnodes),nodeclass(nrnodes),&
        cat(mdim),nodestatus(nrnodes),nbestcat(maxcat,nrnodes),&
        joob(nout),pjoob(nout)
        integer nsample,mdim,nout,mr,nrnodes,ndbigtree,maxcat
!
!       output:
        integer jvr(nout),nodexvr(nout)
!
        integer n,kt,k,m,jcat
        real xmn
!
        call permobmr(joob,pjoob,nout)
        n=1
904     kt=1
        do k=1,ndbigtree
                if (nodestatus(kt).eq.-1) then
                        jvr(n)=nodeclass(kt)
                        nodexvr(n)=kt
                        goto 100
                endif
                m=bestvar(kt)
                if(m.eq.mr) then
                        xmn=x(m,pjoob(n)) ! permuted value
                else
                        xmn=x(m,joob(n))
                endif
                if (cat(m).eq.1) then
                        if (xmn.le.xbestsplit(kt)) then 
                                kt=treemap(1,kt)
                        else
                                kt=treemap(2,kt)
                        endif
                endif
                if(cat(m).gt.1) then
                        jcat=nint(xmn)
                        if (nbestcat(jcat,kt).eq.1) then
                                kt=treemap(1,kt)
                        else
                                kt=treemap(2,kt)
                        endif
                endif
        enddo !k
100     n=n+1
        if(n.le.nout) goto 904
        end
!
!       -------------------------------------------------------
        subroutine permobmr(joob,pjoob,nout)
!
!       randomly permute the elements of joob and put them in pjoob
!
!       input:
        integer joob(nout),nout
!       output:
        integer pjoob(nout)
!       local:
        integer j,k,jt
        real rnd,randomu
!
        do j=1,nout
                pjoob(j)=joob(j)
        enddo 
        j=nout
11      rnd=randomu()
        k=int(j*rnd)
        if(k.lt.j) k=k+1
!       switch j and k
        jt=pjoob(j)
        pjoob(j)=pjoob(k)
        pjoob(k)=jt
        j=j-1
        if(j.gt.1) go to 11
        end
!
!       -------------------------------------------------------
        subroutine comperrtr(q,cl,nsample,nclass,errtr,&
        tmiss,nc,jest,out)
!
        integer cl(nsample),nc(nclass),jest(nsample),out(nsample)
        real q(nclass,nsample),tmiss(nclass),errtr
        integer nsample,nclass
        real cmax,ctemp
        integer n,j,jmax
        call zervr(tmiss,nclass)
        errtr=0
        do n=1,nsample
                cmax=0
                if(out(n).gt.0) then
                do j=1,nclass
                        ctemp=q(j,n)/out(n)
                        if(ctemp.gt.cmax) then
                                jmax=j
                                cmax=ctemp
                        endif
                enddo
                else
                jmax=1
                endif
                jest(n)=jmax
                if (jmax.ne.cl(n)) then
                        tmiss(cl(n))=tmiss(cl(n))+1
                        errtr=errtr+1
                endif
        enddo
        errtr=errtr/nsample
        do j=1,nclass
                tmiss(j)=tmiss(j)/nc(j)
        enddo
        end
!
!       -------------------------------------------------------
        subroutine comperrts(qts,clts,ntest,nclass,errts,&
        tmissts,ncts,jests,labelts)
!               qts je real pole s hodnotami odezvy kazdeho vzorku pro kazdou tridu
!               kdyz to prepoctu na celkem 100 %, mam pravdepodobnosti jednotlivych trid
!               a pri dvou tridach mohu vynest ROC. 
        integer clts(ntest),ncts(nclass),jests(ntest)
        real qts(nclass,ntest),tmissts(nclass)
        integer ntest,nclass,labelts
        real errts,cmax
        integer n,j,jmax
        call zervr(tmissts,nclass)
        errts=0
        do n=1,ntest    ! cykl pres testovaci vzorky
!       
                cmax=0  !tento blok hleda pro kazdy vzorek maximum v matici qts, 
!                        tj. max. "vystup" cmax a jeho pozici jmax
                do j=1,nclass
                        if (qts(j,n).gt.cmax) then
                                jmax=j
                                cmax=qts(j,n)
                        endif
                enddo
!
                jests(n)=jmax                     ! pozice tridy se pro kazdy vzorek schova do tohoto pole
                if(labelts.eq.1) then             ! kdyz znam soll tridy v clts porovnam to s pozici jmax nalezene tridy
                        if (jmax.ne.clts(n)) then ! a kdyz to neni shodne, zapocitam jednotkovou chybu.
                                tmissts(clts(n))=tmissts(clts(n))+1
                                errts=errts+1
                        endif
                endif
        enddo
        if(labelts.eq.1) then     ! tady se testovaci chyba prepocitava na procenta
                errts=errts/ntest ! pro cely soubor
                do j=1,nclass     ! a pro jednotlive tridy
                        tmissts(j)=tmissts(j)/ncts(j)
                enddo
        endif
        end
!
!       -------------------------------------------------------
        subroutine createclass(x,cl,ns,nsample,mdim)
!
        real x(mdim,nsample)
        integer cl(nsample)
        integer ns,nsample,mdim
        real randomu
        integer n,m,k
!
        do n=1,ns
                cl(n)=1
        enddo
        do n=ns+1,nsample
                cl(n)=2
        enddo
        do n=ns+1,nsample
                do m=1,mdim
                        k=int(randomu()*ns)
                        if(k.lt.ns) k=k+1
                        x(m,n)=x(m,k)
                enddo
        enddo
        end
!
!       -------------------------------------------------------
        subroutine varimp(x,nsample,mdim,cl,nclass,jin,jtr,impn,&
        interact,msm,mdimt,qimp,qimpm,avimp,sqsd,&
        treemap,nodestatus,xbestsplit,bestvar,nodeclass,nrnodes,&
        ndbigtree,cat,jvr,nodexvr,maxcat,nbestcat,tnodewt,&
        nodextr,joob,pjoob,iv)
!
        real x(mdim,nsample),xbestsplit(nrnodes),&
        avimp(mdim),sqsd(mdim),&
        qimp(nsample),qimpm(nsample,mdim),tnodewt(nrnodes)
        integer cl(nsample),jin(nsample),jtr(nsample),&
        msm(mdimt),treemap(2,nrnodes),nodestatus(nrnodes),&
        bestvar(nrnodes),nodeclass(nrnodes),cat(mdim),jvr(nsample),&
        nodexvr(nsample),nbestcat(maxcat,nrnodes),&
        nodextr(nsample),joob(nsample),pjoob(nsample),iv(mdim)
        integer nsample,mdim,nrnodes,ndbigtree,maxcat,&
        nclass,impn,interact,mdimt
        integer nout,mr,nn,n,jj,k
        real right,rightimp
!
        nout=0
        right=0
        do n=1,nsample
        if(jin(n).eq.0) then
!               this case is out-of-bag
!               update count of correct oob classifications
!               (jtr(n)=cl(n) if case n is correctly classified)
                if(jtr(n).eq.cl(n)) right=right+tnodewt(nodextr(n))
!               nout=number of obs out-of-bag for THIS tree
                nout=nout+1
                joob(nout)=n
        endif
        enddo
        if(impn.eq.1) then
                do n=1,nout
                        nn=joob(n)
                        if(jtr(nn).eq.cl(nn)) then
                        qimp(nn)=qimp(nn)+tnodewt(nodextr(nn))/nout
                        endif
                enddo
        endif
        call zerv(iv,mdim)
        do jj=1,ndbigtree
!               iv(j)=1 if variable j was used to split on
                if(nodestatus(jj).ne.-1) iv(bestvar(jj))=1
        enddo
        do k=1,mdimt
                mr=msm(k)
!               choose only those that used a split on variable mr 
                if(iv(mr).eq.1) then
                        call testreeimp(x,nsample,mdim,joob,pjoob,nout,mr,&
                        treemap,nodestatus,xbestsplit,bestvar,nodeclass,nrnodes,&
                        ndbigtree,cat,jvr,nodexvr,maxcat,nbestcat)
                        rightimp=0
                        do n=1,nout
!                               the nth out-of-bag case is the nnth original case
                                nn=joob(n)
                                if(impn.eq.1) then
                                        if(jvr(n).eq.cl(nn)) then
                                                qimpm(nn,mr)=qimpm(nn,mr)+&
                                                tnodewt(nodexvr(n))/nout
                                        endif
                                endif
                                if(jvr(n).eq.cl(nn)) rightimp=rightimp+&
                                                tnodewt(nodexvr(n))
                        enddo
                        avimp(mr)=avimp(mr)+(right-rightimp)/nout
                        sqsd(mr)=sqsd(mr)+((right-rightimp)**2)/(nout**2)
                else
                        do n=1,nout
!                               the nth out-of-bag case is 
!                               the nnth original case
                                nn=joob(n)
                                if(impn.eq.1) then
                                        if(jtr(nn).eq.cl(nn)) then
                                                qimpm(nn,mr)=qimpm(nn,mr)+&
                                                tnodewt(nodextr(nn))/nout
                                        endif
                                endif
                        enddo
                endif
        enddo !k
        end
!
!       -------------------------------------------------------
        subroutine finishimp(mdim,sqsd,avimp,signif,zscore,&
        jbt,mdimt,msm)
!
        real sqsd(mdim),avimp(mdim),zscore(mdim),signif(mdim)
        integer msm(mdim)
        integer mdim,mdimt,k,m1,jbt
        real v,av,se
        real erfcc
        do k=1,mdimt
                m1=msm(k)
                avimp(m1)=avimp(m1)/jbt
                av=avimp(m1)
                se=(sqsd(m1)/jbt)-av*av
                se=sqrt(se/jbt)
                if(se.gt.0.0) then
                        zscore(m1)=avimp(m1)/se
                        v=zscore(m1)
                        signif(m1)=erfcc(v)
                else
                        zscore(m1)=-5
                        signif(m1)=1
                endif
        enddo
        end
!
!       -------------------------------------------------------
        subroutine compinteract(votes,effect,msm,mdim,mdimt,&
        jbt,g,iv,irnk,hist,teffect)
!
        real votes(mdim,jbt),effect(mdim,mdim),g(mdim),&
        hist(0:mdim,mdim),teffect(mdim,mdim)
        integer msm(mdimt),iv(mdim),irnk(mdim,jbt)
        integer mdim,mdimt,jbt,jb,i,nt,irk,j,ii,&
        jj,ij,mmin,m,k
        real gmin,rcor
        do jb=1,jbt
                nt=0
                call zerv(iv,mdim)
                do i=1,mdimt
                        m=msm(i)
                        g(m)=votes(m,jb)
                        if(abs(g(m)).lt.8.232D-11) then
                                irnk(m,jb)=0
                                iv(m)=1
                                nt=nt+1
                        endif
                enddo
                irk=0
                do j=1,8000
                        gmin=10000
                        do i=1,mdimt
                                m=msm(i)
                                if(iv(m).eq.0.and.g(m).lt.gmin) then
                                        gmin=g(m)
                                        mmin=m
                                endif
                        enddo
                        iv(mmin)=1
                        irk=irk+1
                        irnk(mmin,jb)=irk
                        nt=nt+1
                        if(nt.ge.mdimt) goto 79
                enddo !j
79              continue
        enddo !jb
        do j=0,mdimt
                do i=1,mdimt
                        m=msm(i)
                        hist(j,m)=0
                enddo
        enddo
        do i=1,mdimt
                m=msm(i)
                do jb=1,jbt
                        hist(irnk(m,jb),m)=hist(irnk(m,jb),m)+1
                enddo
                do j=0,mdimt
                        hist(j,m)=hist(j,m)/jbt
                enddo
        enddo !m
        
        call zermr(effect,mdim,mdim)
        do i=1,mdimt
                do j=1,mdimt
                        m=msm(i)
                        k=msm(j)
                        do jb=1,jbt
                                effect(m,k)=effect(m,k)+iabs(irnk(m,jb)-irnk(k,jb))
                        enddo
                        effect(m,k)=effect(m,k)/jbt
                enddo
        enddo
        call zermr(teffect,mdim,mdim)
        do i=1,mdimt
                do j=1,mdimt
                        m=msm(i)
                        k=msm(j)
                        do ii=0,mdimt
                                do jj=0,mdimt
                                        teffect(m,k)=teffect(m,k)+abs(ii-jj)*hist(jj,m)*hist(ii,k)
                                enddo
                        enddo
                        rcor=0
                        do ij=1,mdimt
                                rcor=rcor+hist(ij,m)*hist(ij,k)
                        enddo
                        teffect(m,k)=teffect(m,k)/(1-rcor)
                enddo
        enddo

        do i=1,mdimt
                do j=1,mdimt
                        m=msm(i)
                        k=msm(j)
                        effect(m,k)=100*(effect(m,k)-teffect(m,k))
                enddo
        enddo
        end
!
!       -------------------------------------------------------
        subroutine compprot(loz,nrnn,ns,mdim,its,&
        jest,wc,nclass,x,mdimt,msm,temp,cat,maxcat,&
        jpur,inear,nprot,protlow,prothigh,prot,protfreq,&
        protvlow,protvhigh,protv,popclass,npend,freq,v5,v95)
!
        integer nrnn,ns,mdim,nclass,mdimt,nprot,maxcat
        integer loz(ns,nrnn),jest(ns),msm(mdim),its(ns),&
        jpur(nrnn),inear(nrnn),npend(nclass),cat(mdim)
        real wc(ns),prot(mdim,nprot,nclass),&
        protlow(mdim,nprot,nclass),prothigh(mdim,nprot,nclass),&
        protfreq(mdim,nprot,nclass,maxcat),&
        protvlow(mdim,nprot,nclass),protvhigh(mdim,nprot,nclass),&
        x(mdim,ns),temp(nrnn),protv(mdim,nprot,nclass),&
        popclass(nprot,nclass),freq(maxcat),v5(mdim),v95(mdim)
        integer ii,i,k,n,jp,npu,mm,m,nclose,jj,ll,jmax,nn
        real fmax,dt


        do jp=1,nclass
                call zerv(its,ns)
!               we try to find nprot prototypes for this class:
                npend(jp)=nprot
                do i=1,nprot
                        call zervr(wc,ns)
                        do n=1,ns
                                if(its(n).eq.0) then
!                                       wc(n) is the number of unseen neighbors 
!                                       of case n that are predicted to be 
!                                       in class jp
!                                       loz(n,1),...,loz(n,nrnn) point to 
!                                       the nrnn nearest neighbors of 
!                                       case n 
                                        do k=1,nrnn
                                                nn=loz(n,k)
                                                if(its(nn).eq.0) then
                                                        ii=jest(nn)
                                                        if(ii.eq.jp) wc(n)=wc(n)+1
                                                endif
                                        enddo
                                endif
                        enddo
!                       find the unseen case with the largest number 
!                       of unseen predicted-class-jp neighbors
                        nclose=0
                        npu=0
                        do n=1,ns
                                if(wc(n).ge.nclose.and.its(n).eq.0) then
                                        npu=n
                                        nclose=wc(n)
                                endif
                        enddo
!                       if nclose=0,no case has any unseen predicted-class-jp neighbors
!                       can't find another prototype for this class - reduce npend by 1 and
!                       start finding prototypes for the next class
                        if(nclose.eq.0) then
                                npend(jp)=i-1
                                goto 93
                        endif
!                       case npu has the largest number 
!                       of unseen predicted-class-jp neighbors
!                       put these neighbors in a list of length nclose
                        ii=0    
                        do k=1,nrnn
                                nn=loz(npu,k)
                                if(its(nn).eq.0.and.jest(nn).eq.jp) then
                                        ii=ii+1
                                        inear(ii)=nn    
                                endif
                        enddo
!                       popclass is a measure of the size of the cluster around 
!                       this prototype
                        popclass(i,jp)=nclose
                        do mm=1,mdimt
!                               m is the index of the mmth variable
                                m=msm(mm)       
                                if(cat(m).eq.1) then
                                        dt=v95(m)-v5(m)
                                        do ii=1,nclose
!                                               put the value of the mmth variable into the list
                                                temp(ii)=x(m,inear(ii))
                                        enddo !ii
!                                       sort the list
                                        call quicksort(temp,jpur,1,nclose,nclose)
                                        ii=nclose/4
                                        if(ii.eq.0) ii=1
!                                       find the 25th percentile
                                        protvlow(m,i,jp)=temp(ii)
                                        protlow(m,i,jp)=(temp(ii)-v5(m))/dt
                                        ii=nclose/4
                                        ii=(3*nclose)/4
                                        if(ii.eq.0) ii=1
!                                       find the 75th percentile
                                        protvhigh(m,i,jp)=temp(ii)
                                        prothigh(m,i,jp)=(temp(ii)-v5(m))/dt
                                        ii=nclose/2
                                        if(ii.eq.0) ii=1
!                                       find the median
                                        protv(m,i,jp)=temp(ii)
                                        prot(m,i,jp)=(temp(ii)-v5(m))/dt
                                endif   
                                if(cat(m).ge.2) then
!                                       for categorical variables,choose the most frequent class
                                        call zervr(freq,maxcat) 
                                        do k=1,nclose
                                                jj=nint(x(m,loz(npu,k)))        
                                                freq(jj)=freq(jj)+1
                                        enddo   
                                        jmax=1
                                        fmax=freq(1)
                                        do ll=2,cat(m)
                                                if(freq(ll).gt.fmax) then
                                                        jmax=ll
                                                        fmax=freq(ll)
                                                endif
                                        enddo   
                                        protv(m,i,jp)=jmax
                                        protvlow(m,i,jp)=jmax
                                        protvhigh(m,i,jp)=jmax
                                        do ll=1,cat(m)
                                                protfreq(m,i,jp,ll)=freq(ll)
                                        enddo
                                endif
                        enddo !m
!                       record that npu and it's neighbors have been 'seen'
                        its(npu)=1
                        do k=1,nclose
                                nn=loz(npu,k)
                                its(nn)=1
                        enddo
                enddo !nprot
93              continue
        enddo !jp

        end
!
!       -------------------------------------------------------
        subroutine preprox(near,nrnodes,jbt,nodestatus,ncount,jb,&
        nod,nodextr,nodexb,jin,jinb,ncn,ndbegin,kpop,rinpop,npcase,&
        rpop,nsample)
!
        integer near,nrnodes,jbt,jb,nsample,&
        nodestatus(nrnodes),ncount(near,jbt),nod(nrnodes),&
        nodextr(near),nodexb(near,jbt),jin(nsample),jinb(near,jbt),&
        ncn(near),kpop(near),npcase(near,jbt),ndbegin(near,jbt)
        real rpop(near),rinpop(near,jbt)
        integer n, ntt, k, nterm, kn
        
        do n=1,near
                ncount(n,jb)=0
                ndbegin(n,jb)=0
        enddo
        ntt=0
        do k=1,nrnodes
                if(nodestatus(k).eq.-1) then
                        ntt=ntt+1
                        nod(k)=ntt
                endif
        enddo
        nterm=ntt
        do n=1,near
                rinpop(n,jb)=rpop(nodextr(n))
                nodexb(n,jb)=nod(nodextr(n))
                jinb(n,jb)=jin(n)
                k=nodexb(n,jb)
                ncount(k,jb)=ncount(k,jb)+1
                ncn(n)=ncount(k,jb)
        enddo
        ndbegin(1,jb)=1
        do k=2,nterm+1
                ndbegin(k,jb)=ndbegin(k-1,jb)+ncount(k-1,jb)
        enddo
        do n=1,near
                kn=ndbegin(nodexb(n,jb),jb)+ncn(n)-1
                npcase(kn,jb)=n
        enddo
        end
!
!       -------------------------------------------------------
        subroutine comprox(prox,nodexb,jinb,ndbegin,&
        npcase,ppr,rinpop,near,jbt,noutlier,outtr,cl,&
        loz,nrnn,wtx,nsample,iwork,ibest)
!
        double precision prox(near,nrnn),ppr(near)
        real outtr(near),rinpop(near,jbt),wtx(nsample)
        integer nodexb(near,jbt),jinb(near,jbt),&
        ndbegin(near,jbt),npcase(near,jbt),cl(nsample),&
        loz(near,nrnn),iwork(near),ibest(nrnn),&
        near,jbt,noutlier,nrnn,nsample
        integer n,jb,k,j,kk
        real rsq
!
        do n=1,near
                call zervd(ppr,near)
                do jb=1,jbt
                        k=nodexb(n,jb)
                        if(jinb(n,jb).gt.0) then
                                do j=ndbegin(k,jb),ndbegin(k+1,jb)-1
                                        kk=npcase(j,jb)
                                        if(jinb(kk,jb).eq.0) then
                                        ppr(kk)=ppr(kk)+(wtx(n)/rinpop(n,jb))
                                        endif
                                enddo
                        endif
                        if(jinb(n,jb).eq.0) then
                                do j=ndbegin(k,jb),ndbegin(k+1,jb)-1
                                        kk=npcase(j,jb)
                                        if(jinb(kk,jb).gt.0) then
                                        ppr(kk)=ppr(kk)+(wtx(kk)/rinpop(kk,jb))
                                        endif
                                enddo
                        endif
                enddo !jbt
                if(noutlier.eq.1) then
                        rsq=0
                        do k=1,near
                        if(ppr(k).gt.0.and.cl(k).eq.cl(n)) rsq=rsq+ppr(k)*ppr(k)
                        enddo
                        if(rsq.eq.0) rsq=1
                        outtr(n)=near/rsq
                endif
        
                if(nrnn.eq.near) then
                        do k=1,near
                                prox(n,k)=ppr(k)
                                loz(n,k)=k
                        enddo
                else
                        call biggest(ppr,near,nrnn,ibest,iwork)
                        do k=1,nrnn
                                prox(n,k)=ppr(ibest(k))
                                loz(n,k)=ibest(k)
                        enddo
                endif
        enddo !n
        end
!
!       ------------------------------------------------------
        subroutine biggest(x,n,nrnn,ibest,iwork)
!
        double precision x(n)
        integer n,nrnn,ibest(nrnn),iwork(n)
        integer i,j,ihalfn,jsave
!
!       finds the nrnn largest values in the vector x and 
!       returns their positions in the vector ibest(1),...,ibest(nrnn):
!               x(ibest(1)) is the largest
!               ...
!               x(ibest(nrnn)) is the nrnn-th-largest
!       the vector x is not disturbed 
!       the vector iwork is used as workspace
!
        ihalfn=int(n/2)
        do i=1,n
                iwork(i)=i
        enddo
        do j=1,ihalfn
                i=ihalfn + 1 - j
                call sift(x,iwork,n,n,i)
        enddo
        do j=1,nrnn-1
                i=n-j+1
                ibest(j)=iwork(1)
                jsave=iwork(i)
                iwork(i)=iwork(1)
                iwork(1)=jsave
                call sift(x,iwork,n,n-j,1)
        enddo
        ibest(nrnn)=iwork(1)
        end
!
!       ------------------------------------------------------
        subroutine sift(x,iwork,n,m,i)
!
        double precision x(n)
        integer iwork(m),n,m,i
        real xsave
        integer j,k,jsave,ksave
!
!       used by subroutine biggest,to bring the largest element to the 
!       top of the heap
!
        xsave=x(iwork(i))
        ksave=iwork(i)
        jsave=i
        j=i + i
        do k=1,m
                if( j.gt.m ) goto 10
                if( j.lt.m ) then
                        if( x(iwork(j)).lt.x(iwork(j+1)) ) j=j + 1
                endif
                if( xsave.ge.x(iwork(j)) ) goto 10
                iwork(jsave)=iwork(j)
                jsave=j
                j=j + j
        enddo
10      continue
        iwork(jsave)=ksave
        return
        end
!
!       ------------------------------------------------------
        subroutine locateout(cl,tout,outtr,ncp,isort,devout,&
        near,nsample,nclass,rmedout)
!
        real outtr(near),tout(near),devout(nclass),rmedout(nclass)
        integer cl(nsample),isort(nsample),ncp(near),near,nsample,&
        nclass
        real rmed, dev
        integer jp,nt,n,i
     
        do jp=1,nclass
                nt=0
                do n=1,near
                        if(cl(n).eq.jp) then
                                nt=nt+1
                                tout(nt)=outtr(n)
                                ncp(nt)=n
                        endif
                enddo
                call quicksort(tout,isort,1,nt,nsample)
                rmed=tout((1+nt)/2)
                dev=0
                do i=1,nt
                        dev=dev+amin1(abs(tout(i)-rmed),5*rmed)
                enddo
                dev=dev/nt
                devout(jp)=dev
                rmedout(jp)=rmed
                do i=1,nt
                        outtr(ncp(i))=amin1((outtr(ncp(i))-rmed)/dev,20.0)
                enddo
        enddo !jp
        end

!       -------------------------------------------------------
        subroutine myscale(loz,prox,xsc,y,u,near,nscale,red,nrnn,&
        ee,ev,dl)
!
        double precision prox(near,nrnn),y(near),u(near),dl(nscale),&
        xsc(near,nscale),red(near),ee(near),ev(near,nscale),bl(10)
        integer loz(near,nrnn)
!
        integer near,nscale,nrnn,j,i,it,n,jit,k
        double precision dotd,y2,sred,eu,ru,ra,ynorm,sa
        do j=1,near
                ee(j)=dble(1.)
        enddo
!
        do j=1,near
                red(j)=0
                do i=1,nrnn
                        red(j)=red(j)+prox(j,i)
                enddo
                red(j)=red(j)/near
        enddo
        sred=dotd(ee,red,near)
        sred=sred/near
        do it=1,nscale
                do n=1,near
                        if(mod(n,2).eq.0) then
                                y(n)=1
                        else
                                y(n)=-1
                        endif
                enddo
                do jit=1,1000
                        y2=dotd(y,y,near)
                        y2=dsqrt(y2)
                        do n=1,near
                                u(n)=y(n)/y2
                        enddo
                        do n=1,near
                                y(n)=0
                                do k=1,nrnn
                                        y(n)=y(n)+prox(n,k)*u(loz(n,k))
                                enddo
                        enddo
                        eu=dotd(ee,u,near)
                        ru=dotd(red,u,near)
                        do n=1,near
                                y(n)=y(n)-(red(n)-sred)*eu-ru
                                y(n)=.5*y(n)
                        enddo
                        if(it.gt.1) then
                                do j=1,it-1
                                        bl(j)=0
                                        do n=1,near
                                                bl(j)=bl(j)+ev(n,j)*u(n)
                                        enddo
                                        do n=1,near
                                                y(n)=y(n)-bl(j)*dl(j)*ev(n,j)
                                        enddo
                                enddo
                        endif
                        ra=dotd(y,u,near)
                        ynorm=0
                        do n=1,near
                                ynorm=ynorm+(y(n)-ra*u(n))**2
                        enddo
                        sa=dabs(ra)
                        if(ynorm.lt.sa*1.0e-7)then
                                do n=1,near
                                        xsc(n,it)=(dsqrt(sa))*u(n)
                                        ev(n,it)=u(n)
                                enddo
                                dl(it)=ra
                                goto 101
                        endif
                enddo
101             continue
        enddo !nn
        end
!
!       -------------------------------------------------------

        subroutine xfill(x,nsample,mdim,fill,code)
!       
!       input:
        real code,fill(mdim)
        integer mdim,nsample
!       output:
        real x(mdim,nsample)
!       local:
        integer n,m
        do n=1,nsample
                do m=1,mdim
                        if(abs(x(m,n)-code).lt.8.232D-11) &
                                x(m,n)=fill(m)
                enddo !m
        enddo
        end
!
!       -------------------------------------------------------
        subroutine roughfix(x,v,ncase,mdim,nsample,cat,code,&
        nrcat,maxcat,fill)
!
        real x(mdim,nsample),v(nsample),fill(mdim),code
          integer ncase(nsample),cat(mdim),nrcat(maxcat)
        integer mdim,nsample,maxcat
        integer m,n,nt,j,jmax,lcat,nmax
        real rmed
!
        do m=1,mdim
                if(cat(m).eq.1) then
!                       continuous variable
                        nt=0
                        do n=1,nsample
                                if(abs(x(m,n)-code).ge.8.232D-11) then
                                        nt=nt+1
                                        v(nt)=x(m,n)
                                endif
                        enddo
                        call quicksort (v,ncase,1,nt,nsample)
                        if(nt.gt.0) then
                                rmed=v((nt+1)/2)
                        else
                                rmed=0
                        endif
                        fill(m)=rmed
                else
!                       categorical variable
                        lcat=cat(m)
                        call zerv(nrcat,maxcat)
                        do n=1,nsample
                                if(abs(x(m,n)-code).ge.8.232D-11) then
                                        j=nint(x(m,n))
                                        nrcat(j)=nrcat(j)+1
                                endif
                        enddo
                        nmax=0
                        jmax=1
                        do j=1,lcat
                                if(nrcat(j).gt.nmax) then
                                        nmax=nrcat(j)
                                        jmax=j
                                endif
                        enddo
                        fill(m)=real(jmax)
                endif
        enddo !m
        do n=1,nsample
                do m=1,mdim
                        if(abs(x(m,n)-code).lt.8.232D-11) x(m,n)=fill(m)
                enddo
        enddo
        end

!       -------------------------------------------------------
        subroutine impute(x,prox,near,mdim,&
        maxcat,votecat,cat,nrnn,loz,missing)
!
        real x(mdim,near),votecat(maxcat)
        double precision  prox(near,nrnn)
        integer near,mdim,maxcat,nrnn
        integer cat(mdim),loz(near,nrnn),&
        missing(mdim,near)
        integer i,j,jmax,m,n,k
        real sx,dt,rmax
!
        do m=1,mdim
                if(cat(m).eq.1) then
                        do n=1,near
                                if(missing(m,n).eq.1) then
                                        sx=0
                                        dt=0
                                        do k=1,nrnn
                                                if(missing(m,loz(n,k)).ne.1) then
                                                        sx=sx+real(prox(n,k))*x(m,loz(n,k))
                                                        dt=dt+real(prox(n,k))
                                                endif
                                        enddo
                                        if(dt.gt.0) x(m,n)=sx/dt
                                endif
                        enddo !n
                endif
        enddo !m
        do m=1,mdim
                if(cat(m).gt.1) then
                        do n=1,near
                                if(missing(m,n).eq.1) then
                                        call zervr(votecat,maxcat)
                                        do k=1,nrnn
                                                if (missing(m,loz(n,k)).ne.1) then
                                                        j=nint(x(m,loz(n,k)))
                                                        votecat(j)=votecat(j)+real(prox(n,k))
                                                endif
                                        enddo !k
                                        rmax=-1
                                        do i=1,cat(m)
                                                if(votecat(i).gt.rmax) then
                                                        rmax=votecat(i)
                                                        jmax=i
                                                endif
                                        enddo
                                        x(m,n)=real(jmax)
                                endif
                        enddo !n
                endif
        enddo !m
        end
!
!       -------------------------------------------------------
        subroutine checkin(labelts,labeltr,nclass,lookcls,jclasswt,&
        mselect,mdim2nd,mdim,imp,impn,interact,nprox,nrnn,&
        nsample,noutlier,nscale,nprot,missfill,iviz,isaverf,&
        irunrf,isavepar,ireadpar,isavefill,ireadfill,isaveprox,&
        ireadprox,isumout,idataout,impfastout,impout,interout,&
        iprotout,iproxout,iscaleout,ioutlierout,cat,maxcat,cl)
!
        integer labelts,labeltr,nclass,lookcls,jclasswt,mselect,&
        mdim2nd,mdim,imp,impn,interact,nprox,nrnn,nsample,noutlier,&
        nscale,nprot,missfill,iviz,isaverf,irunrf,isavepar,ireadpar,&
        isavefill,ireadfill,isaveprox,ireadprox,isumout,idataout,&
        impfastout,impout,interout,iprotout,iproxout,iscaleout,&
        ioutlierout,cat(mdim),maxcat,cl(nsample)
!
        integer n,m
!
        if(labelts.ne.0.and.labelts.ne.1) then
                write(*,*) 'error labelts',labelts
                stop
        endif
        if(labeltr.ne.0.and.labeltr.ne.1) then
                write(*,*) 'error labeltr',labeltr
                stop
        endif
        if(labeltr.eq.0.and.nclass.ne.2) then
                write(*,*) 'error,nclass should be 2 if labeltr=0'
                stop
        endif
        if(lookcls.ne.0.and.lookcls.ne.1) then
                write(*,*) 'error lookcls',lookcls
                stop
        endif
        if(jclasswt.ne.0.and.jclasswt.ne.1) then
                write(*,*) 'error jclasswt',jclasswt
                stop
        endif
        if(mselect.ne.0.and.mselect.ne.1) then
                write(*,*) 'error mselect',mselect
                stop
        endif
        if(mdim2nd.lt.0.or.mdim2nd.gt.mdim) then
                write(*,*) 'error mdim2nd',mdim2nd
                stop
        endif
        if(imp.ne.0.and.imp.ne.1) then
                write(*,*) 'error imp',imp
                stop
        endif
        if(impn.ne.0.and.impn.ne.1) then
                write(*,*) 'error impn',impn
                stop
        endif
        if(interact.ne.0.and.interact.ne.1) then
                write(*,*) 'error interact',interact
                stop
        endif
        if(nprox.lt.0.or.nprox.gt.1) then
                write(*,*) 'error nprox',nprox
                stop
        endif
        if(nrnn.lt.0.or.nrnn.gt.nsample) then
                write(*,*) 'error - nrnn',nrnn
                stop
        endif
        if(noutlier.lt.0.or.noutlier.gt.2) then
                write(*,*) 'error - noutlier',noutlier
                stop
        endif
        if(nscale.lt.0.or.nscale.gt.mdim) then
                write(*,*) 'error - nscale',nscale
                stop
        endif
        if(nprot.lt.0.or.nprot.gt.nsample) then
                write(*,*) 'error - nprot',nprot
                stop
        endif
        if(missfill.lt.0.or.missfill.gt.2) then
                write(*,*) 'error missfill',missfill
                stop
        endif
        if(iviz.ne.0.and.iviz.ne.1) then
                write(*,*) 'error iviz',iviz
                stop
        endif
        if(iviz.eq.1.and.impn.ne.1) then
                write(*,*) 'error iviz=1 and impn=',impn
                stop
        endif
        if(iviz.eq.1.and.imp.ne.1) then
                write(*,*) 'error iviz=1 and imp=',imp
                stop
        endif
        if(iviz.eq.1.and.nprox.ne.1) then
                write(*,*) 'error iviz=1 and nprox=',nprox
                stop
        endif
        if(iviz.eq.1.and.nscale.ne.3) then
                write(*,*) 'error iviz=1 and nscale=',nscale
                stop
        endif
        if(isaverf.ne.0.and.isaverf.ne.1) then
                write(*,*) 'error isaverf',isaverf
                stop
        endif
        if(isaverf.eq.1.and.missfill.eq.2) then
                write(*,*) 'error - only rough fix can be saved'
                stop
        endif
        if(irunrf.ne.0.and.irunrf.ne.1) then
                write(*,*) 'error irunrf',irunrf
                stop
        endif
        if(isavepar.ne.0.and.isavepar.ne.1) then
                write(*,*) 'error isavepar',isavepar
                stop
        endif
        if(ireadpar.ne.0.and.ireadpar.ne.1) then
                write(*,*) 'error ireadpar',ireadpar
                stop
        endif
        if(isavefill.ne.0.and.isavefill.ne.1) then
                write(*,*) 'error isavefill',isavefill
                stop
        endif
        if(ireadfill.ne.0.and.ireadfill.ne.1) then
                write(*,*) 'error ireadfill',ireadfill
                stop
        endif
        if(isaveprox.ne.0.and.isaveprox.ne.1) then
                write(*,*) 'error isaveprox',isaveprox
                stop
        endif
        if(ireadprox.ne.0.and.ireadprox.ne.1) then
                write(*,*) 'error ireadprox',ireadprox
                stop
        endif
        if(isumout.lt.0.or.isumout.gt.1) then
                write(*,*) 'error isumout',isumout
                stop
        endif
        if(idataout.lt.0.or.idataout.gt.2) then
                write(*,*) 'error idataout',idataout
                stop
        endif
        if(impfastout.lt.0.or.impfastout.gt.1) then
                write(*,*) 'error impfastout',impfastout
                stop
        endif
        if(impout.lt.0.or.impout.gt.2) then
                write(*,*) 'error impout',impout
                stop
        endif
        if(interout.lt.0.or.interout.gt.2) then
                write(*,*) 'error interout',interout
                stop
        endif
        if(iprotout.lt.0.or.iprotout.gt.2) then
                write(*,*) 'error iprotout',iprotout
                stop
        endif
        if(iproxout.lt.0.or.iproxout.gt.2) then
                write(*,*) 'error iproxout',iproxout
                stop
        endif
        if(iscaleout.lt.0.or.iscaleout.gt.1) then
                write(*,*) 'error iscaleout',iscaleout
                stop
        endif
        if(ioutlierout.lt.0.or.ioutlierout.gt.2) then
                write(*,*) 'error ioutlierout',ioutlierout
                stop
        endif
        if(noutlier.gt.0.and.nprox.eq.0) then
                write(*,*) 'error - noutlier>0 and nprox=0'
                stop
        endif
        if(nscale.gt.0.and.nprox.eq.0) then
                write(*,*) 'error - nscale>0 and nprox=0'
                stop
        endif
        if(nprot.gt.0.and.nprox.eq.0) then
                write(*,*) 'error - nprot>0 and nprox=0'
                stop
        endif
        if(mdim2nd.gt.0.and.imp.eq.0) then
                write(*,*) 'error - mdim2nd>0 and imp=0'
                stop
        endif
        if(impn.gt.0.and.imp.eq.0) then
                write(*,*) 'error - impn>0 and imp=0'
                stop
        endif
        do m=1,mdim
                if(cat(m).gt.maxcat) then
                        write(*,*) 'error in cat',m,cat(m)
                        stop
                endif
        enddo
        if(labeltr.eq.1) then
                do n=1,nsample
                        if(cl(n).lt.1.or.cl(n).gt.nclass) then 
                                write(*,*) 'error in class label',n,cl(n)
                                stop
                        endif
                enddo
        endif
        return
        end
!
!       -------------------------------------------------------
        subroutine quicksort(v,iperm,ii,jj,kk)
!
!       puts into iperm the permutation vector which sorts v into
!       increasing order.  only elementest from ii to jj are considered.
!       array iu(k) and array il(k) permit sorting up to 2**(k+1)-1 elements
!
!       this is a modification of acm algorithm #347 by r. c. singleton,
!       which is a modified hoare quicksort.
!
        real v(kk),vt,vtt
        integer t,tt,iperm(kk),iu(32),il(32)
        integer ii,jj,kk,m,i,j,k,ij,l
!
        m=1
        i=ii
        j=jj
 10     if (i.ge.j) go to 80
 20     k=i
        ij=(j+i)/2
        t=iperm(ij)
        vt=v(ij)
        if (v(i).le.vt) go to 30
        iperm(ij)=iperm(i)
        iperm(i)=t
        t=iperm(ij)
        v(ij)=v(i)
        v(i)=vt
        vt=v(ij)
 30     l=j
        if (v(j).ge.vt) go to 50
        iperm(ij)=iperm(j)
        iperm(j)=t
        t=iperm(ij)
        v(ij)=v(j)
        v(j)=vt
        vt=v(ij)
        if (v(i).le.vt) go to 50
        iperm(ij)=iperm(i)
        iperm(i)=t
        t=iperm(ij)
        v(ij)=v(i)
        v(i)=vt
        vt=v(ij)
        go to 50
 40     iperm(l)=iperm(k)
        iperm(k)=tt
        v(l)=v(k)
        v(k)=vtt
 50     l=l-1
        if (v(l).gt.vt) go to 50
        tt=iperm(l)
        vtt=v(l)
 60     k=k+1
        if (v(k).lt.vt) go to 60
        if (k.le.l) go to 40
        if (l-i.le.j-k) go to 70
        il(m)=i
        iu(m)=l
        i=k
        m=m+1
        go to 90
 70     il(m)=k
        iu(m)=j
        j=l
        m=m+1
        go to 90
 80     m=m-1
        if (m.eq.0) return
        i=il(m)
        j=iu(m)
 90     if (j-i.gt.10) go to 20
        if (i.eq.ii) go to 10
        i=i-1
 100    i=i+1
        if (i.eq.j) go to 80
        t=iperm(i+1)
        vt=v(i+1)
        if (v(i).le.vt) go to 100
        k=i
 110    iperm(k+1)=iperm(k)
        v(k+1)=v(k)
        k=k-1
        if (vt.lt.v(k)) go to 110
        iperm(k+1)=t
        v(k+1)=vt
        go to 100
        end
!
!       -------------------------------------------------------
        subroutine unpack(l,npack,icat)
!
        integer icat(32),npack,l,j,n,k
        if(l.gt.32) then
                write(*,*) 'error in unpack,l=',l
                stop
        endif
        do j=1,32
                icat(j)=0
        enddo
        n=npack
        icat(1)=mod(n,2)
        do k=2,l
                n=(n-icat(k-1))/2
                icat(k)=mod(n,2)
        enddo
        end
!
!       -------------------------------------------------------
        subroutine zerv(ix,m1)
!
        integer ix(m1),m1,n
        do n=1,m1
                ix(n)=0
        enddo
        end
!
!       -------------------------------------------------------
        subroutine zervr(rx,m1)
!
        real rx(m1)
        integer m1,n
        do n=1,m1
                rx(n)=0
        enddo
        end
!
!       -------------------------------------------------------

        subroutine zervd(rx,m1)
!
        double precision rx(m1)
        integer m1,n
        do n=1,m1
                rx(n)=0
        enddo
        end
!       
!       ________________________________________________________

        subroutine zerm(mx,m1,m2)
!
        integer mx(m1,m2),m1,m2,i,j
        do j=1,m2
                do i=1,m1
                        mx(i,j)=0
                enddo
        enddo
        end
!
!       -------------------------------------------------------
        subroutine zermr(rx,m1,m2)
!
        real rx(m1,m2)
        integer m1,m2,i,j
        do j=1,m2
                do i=1,m1
                        rx(i,j)=0
                enddo
        enddo
        end
!
!       -------------------------------------------------------
        subroutine zermd(rx,m1,m2)
!
        double precision rx(m1,m2)
        integer m1,m2,i,j
        do j=1,m2
                do i=1,m1
                        rx(i,j)=0
                enddo
        enddo
        end
!
!       -------------------------------------------------------
        real function erfcc(x)
!
        real x,t,z
        z=abs(x)/1.41421356
        t=1./(1.+0.5*z)
        erfcc=t*exp(-z*z-1.26551223+t*(1.00002368+t*(.37409196+t*&
        (.09678418+t*(-.18628806+t*(.27886807+t*(-1.13520398+t*&
        (1.48851587+t*(-.82215223+t*.17087277)))))))))
        erfcc=erfcc/2
        if (x.lt.0.) erfcc=2.-erfcc
        return
        end
!
!       -------------------------------------------------------
        integer function irbit(iseed)
!
        integer iseed, ib1, ib2, ib5, ib18, mask
        parameter(ib1=1,ib2=2,ib5=16,ib18=131072,mask=ib1+ib2+ib5)
        if(iand(iseed,ib18).ne.0) then
                iseed=ior(ishft(ieor(iseed,mask),1),ib1)
                irbit=1
        else
                iseed=iand(ishft(iseed,1),not(ib1))
                irbit=0
        endif
        return
        end
!
!       -------------------------------------------------------
        real function randomu()
!
        double precision grnd,u
        u=grnd()
        randomu=real(u)
        end
!
!       -------------------------------------------------------
        real function rnorm(i)
!
        integer i
        real randomu
        rnorm=sqrt(-2*log(randomu()))*cos(6.283185*randomu())
        end
!
!       -------------------------------------------------------
        double precision function dotd(u,v,ns)
!
!       computes the inner product
!       input:
        double precision u(ns),v(ns)
        integer ns
!       local:
        integer n
        dotd=dble(0.0)
        do n=1,ns
                dotd=dotd+u(n)*v(n)
        enddo
        end
!**************************************************************************
! A C-program for MT19937: Real number version
!   genrand() generates one pseudorandom real number (double)
! which is uniformly distributed on [0,1]-interval,for each
! call. sgenrand(seed) set initial values to the working area
! of 624 words. Before genrand(),sgenrand(seed) must be
! called once. (seed is any 32-bit integer except for 0).
! Integer generator is obtained by modifying two lines.
!   Coded by Takuji Nishimura,considering the suggestions by
! Topher Cooper and Marc Rieffel in July-Aug. 1997.
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Library General Public
! License as published by the Free Software Foundation; either
! version 2 of the License,or (at your option) any later
! version.
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
! See the GNU Library General Public License for more details.
! You should have received a copy of the GNU Library General
! Public License along with this library; if not,write to the
! Free Foundation,Inc.,59 Temple Place,Suite 330,Boston,MA
! 02111-1307  USA
!
! Copyright (C) 1997 Makoto Matsumoto and Takuji Nishimura.
! When you use this,send an email to: matumoto@math.keio.ac.jp
! with an appropriate reference to your work.
!
! Fortran translation by Hiroshi Takano.  Jan. 13,1999.
!************************************************************************
! This program uses the following non-standard intrinsics.
!   ishft(i,n): If n>0,shifts bits in i by n positions to left.
!                  If n<0,shifts bits in i by n positions to right.
!   iand (i,j): Performs logical AND on corresponding bits of i and j.
!   ior  (i,j): Performs inclusive OR on corresponding bits of i and j.
!   ieor (i,j): Performs exclusive OR on corresponding bits of i and j.
!
!***********************************************************************
        subroutine sgrnd(seed)
!
        implicit integer(a-z)
!
!       Period parameters
        parameter(n    = 624)
!
        dimension mt(0:n-1)
!                          the array for the state vector
        common /block/mti,mt
        save   /block/
!
!       setting initial seeds to mt[n] using
!       the generator Line 25 of Table 1 in
!       [KNUTH 1981,The Art of Computer Programming
!          Vol. 2 (2nd Ed.),pp102]
!
        mt(0)=iand(seed,-1)
        do 1000 mti=1,n-1
          mt(mti)=iand(69069 * mt(mti-1),-1)
1000    continue
!
        return
        end
!***********************************************************************
        double precision function grnd()
!
        implicit integer(a-z)
!
!       Period parameters
        parameter(n    = 624)
        parameter(n1   = n+1)
        parameter(m    = 397)
        parameter(mata =-1727483681)
!                                               constant vector a
        parameter(umask=-2147483648)
!                                               most significant w-r bits
        parameter(lmask= 2147483647)
!                                               least significant r bits
! Tempering parameters
        parameter(tmaskb=-1658038656)
        parameter(tmaskc=-272236544)
!
        dimension mt(0:n-1)
!                          the array for the state vector
        common /block/mti,mt
        save   /block/
        data   mti/n1/
!                          mti==n+1 means mt[n] is not initialized
!
        dimension mag01(0:1)
        data mag01/0,mata/
        save mag01
!                               mag01(x)=x * mata for x=0,1
!
        TSHFTU(y)=ishft(y,-11)
        TSHFTS(y)=ishft(y,7)
        TSHFTT(y)=ishft(y,15)
        TSHFTL(y)=ishft(y,-18)
!
        if(mti.ge.n) then
!                            generate n words at one time
          if(mti.eq.n+1) then
!                                   if sgrnd() has not been called,
            call sgrnd(4357)
!                                       a default initial seed is used
          endif
!
          do 1000 kk=0,n-m-1
                y=ior(iand(mt(kk),umask),iand(mt(kk+1),lmask))
                mt(kk)=ieor(ieor(mt(kk+m),ishft(y,-1)),mag01(iand(y,1)))
 1000   continue
          do 1100 kk=n-m,n-2
                y=ior(iand(mt(kk),umask),iand(mt(kk+1),lmask))
                mt(kk)=ieor(ieor(mt(kk+(m-n)),ishft(y,-1)),mag01(iand(y,1)))
 1100   continue
          y=ior(iand(mt(n-1),umask),iand(mt(0),lmask))
          mt(n-1)=ieor(ieor(mt(m-1),ishft(y,-1)),mag01(iand(y,1)))
          mti=0
        endif
!
        y=mt(mti)
        mti=mti+1
        y=ieor(y,TSHFTU(y))
        y=ieor(y,iand(TSHFTS(y),tmaskb))
        y=ieor(y,iand(TSHFTT(y),tmaskc))
        y=ieor(y,TSHFTL(y))
!
        if(y.lt.0) then
                grnd=(dble(y)+2.0d0**32)/(2.0d0**32-1.0d0)
        else
                grnd=dble(y)/(2.0d0**32-1.0d0)
        endif
!
        return
        end
!
!
        function mylen(str)   ! 11 June 2010
!               Computes length of a string not counting spaces from the right. 
!               Two spaces between other charactes are admissible.
            character*1 str
            mezcount=0
            lastpos=0
            do i=1,500
                if(str(i:i).eq.' ') then
                    mezcount=mezcount+1
                    if(mezcount.GE.3) then
                        mylen=lastpos
                        return
                    endif
                else
                    lastpos=i
                    mezcount=0
                endif
            enddo
        end
!
!
